use strict ;
use warnings ;

#note: there is bugs. 2 appeared in MEF album:
# 1e: it happens that a new photo did not had the thumbnail recreated
# 2e: in file:///C:/data/public/mains-en-fete/photos/album/index.html: main title is missing
#      -> corrected in 6.6: different files where created based on trees created from the same element used several times. Correction: clone an element befor adding it to a tree if you want to add it also in anothyer tree.

#####################################################################
#####               Global variables                            #####
#####################################################################

#version of this file, calling script or library. Variable not shared. version v, numeric, decimal 2 digits, 00.00 <= v <= 99.99
my $STD_Version=sprintf("%.2f",   6.6       );

# other scripts, when executed with option -v will display:
#   library_version/script_version


my $STD_TmpDir=File::Spec->tmpdir;

my %Guts ;	       # Internal parameters

# %ConfigTable;       # will contain the album options after we read them from the file

## When reading ConfigTable, it is important that all elements are set, either undef if not defined, either '' or other if definedd
my %languages;         # Hash of ref to language sets 

my ($StampDate) ;
my $language_bundle;   # ref to hash: will be the set of messages depending of the language
#my $ConfigFile ;       # will the the abs path of the file that contaisn album options


my (%WidthesDesBigImages, %HeightsDesBigImages, %SizesDesBigImages, 
    %WidthesDesThumbNails, %HeightsDesThumbNails, %SizesDesThumbNails,
    %PremChapitrDeCetteImage, %NomDesRef, %NomDesTN, %ThumbNailInLog,
    %DescriptionACD) ;

my $MEID='L'; #Module error ID
my ($CR, $CR_in_comment);
my $ModeSilence=0;

#internal for use of Find
my @cumuldirlist ;   # used by deltree
my %File_Find_Data_Struct; # used by smart update (uses find)
my $TreeSize=0; # Used for treesize_wanted_noref

my @Defined_languages=('fr', 'us');

my $Error_message='';
my $Error_message_extended='';

sub set_error
  {
  $Error_message=$_[0];
  $Error_message_extended=$_[1] if ($#_ +1 == 2);
  return undef;
  }

sub set_error_4p
  {
  my $Error_module=$_[0];
  my $Error_ID=$_[1];
  $Error_message="Error $Error_module-$Error_ID. $_[2]";
  $Error_message_extended=$_[3] if ($#_ +1 == 2);
  return undef;
  }

sub get_error
  {
  if ($_[0] == 0 )
    { return $Error_message ; }
  else
    { return $Error_message_extended ; }
  }
#Error management for GUI
#Function will return error status and will set 2 error message: one short and one verbose
# perl TK overides the 'die' and replace it by errorn message.
# Each function that is susceptible to generate unrecoverable errors (error that would generate die in command line proicess) and which may be a chilf or grand-child of GUI should not use 'die' but 'return undef' using return set_error("error_message");
  # return set_error("$MEID-1530 - unable to open $configfile for edit");
#####################################################################
#####               Global internal parameters (guts)           #####
#####################################################################
## The guts will be initialised with some information from the caller script:
##  script directory
##  name of the calling script
##  ID of the calling script
##  name of the library
##  usage :
# init_guts($calling_script_ID, $calling_script, $script_dir, $lib_name)
sub init_guts
  {
  my $nbparam=4; my $funcname='init_guts';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my ($calling_script_ID, $calling_script, $script_dir, $lib_name)=(@_) ;

  $Guts{guts_copyright_notice}= "Copyright (c) Dr Baptiste Marcel 2002, 2003 and later.\nThis programms is freeware, you can modify and/or distribute them under the term of the GNU General Public License version 2 or later. It comes with no warranty of any sort. Refer to www.gnu.org/copyleft/gpl.html for the full text of the GNU GPL." ;          

  $Guts{guts_lib_version}= $STD_Version ;          
  $Guts{guts_def_language}= "us" ;          
  $Guts{guts_def_thumb_surf}= 40000 ;          

## All files, including the lib and the caller files, should be in the same directory.
## Only the caller script know the caller directory

  $Guts{guts_product_name}= 'Albagtor' ;          



#Package list: ref to anonymous array
  my @guts_package_list=('guts_ftp_script', 'guts_product_name_line_cmd', 'guts_product_name_graphical', 'guts_product_name_indexer');
  $Guts{guts_package_list}= \@guts_package_list ;          

#default values if not overided by the caller script:
  $Guts{guts_ftp_script}= 'ftp_sync.pl' ;          
  $Guts{guts_product_name_line_cmd}= 'albagtor.pl' ;          
  $Guts{guts_product_name_graphical}= 'albagraph.pl' ;          
  $Guts{guts_product_name_indexer}= 'albadx.pl' ;    

  $Guts{guts_product_lib}= $lib_name ;          
  $Guts{guts_script_dir}= $script_dir ;          

  $Guts{calling_script_ID}=$calling_script_ID ;
  $Guts{$calling_script_ID}=$calling_script ;

  my $ConfigIniName="$Guts{guts_product_lib}.ini";
  $ConfigIniName =~ s/\.pl\.ini$/.ini/i ;

  $Guts{guts_inifile}= File::Spec->catfile ($Guts{guts_script_dir}, $ConfigIniName);;          

  $Guts{guts_LOG_PATH}=     "logs" ;          
  $Guts{guts_REF_PATH}=     "ref" ;          
  $Guts{guts_TN_PATH}=      "tn" ;          
  $Guts{guts_ALBUM_PATH}=   "album" ;          
  $Guts{guts_ALB_PATH_N}=   "albxxxnewdun" ;          
  $Guts{guts_ALB_PATH_O}=   "albxxxolddun" ;          
  $Guts{guts_RDIR_FN}=      "index.html" ;          
  $Guts{guts_I1AG_FN}=      "index.html" ;          
  $Guts{guts_ATAG_FN}=      "index.html" ;          
  $Guts{guts_ITAG_FN}=      "fullindex.html" ;          
  $Guts{guts_ITNG_FN}=      "fullindex_skel.html" ;          

  $Guts{guts_default_chapter}=      "new" ;          

  $StampDate=get_stampdate();

  # $generator = lc($STD_ScriptName) ;
  }                   

# historic
#####################################################################
#####                         Online doc                        #####
#####################################################################
#Fabrique des albums photos  partir de rpertoires pleins de photos.
#Un rpertoire contient les photos de ref (tous chapitres confondus)
#Un fichier contient les descritptions
#Un rpertoire contient  les sous-rpertoires qui correspondent  des chapitres.
#Chaque sous-rpertoire contient les thumb-nails de son chapitre
#Pas rcursif
#3.4: use direct read for image size because much faster thau image-magick subroutines
#3.6: Workaround for unicode support + correct bug 'head' instead of 'header'
#4.0: multi-language support
#4.1: support option -T (rebuild all thumbnails
#4.2: Able to update stampdate in logs (use '$StampDate' which will be replaced by stampdate)
#4.5: bug when chapter titles include HTML tags. Corrected using 'CloneList'
#5.0: change command-code from sequential to asynchronous (slowly shift to graphic interface)
#6.0: separate variable + actions in one file, function in another file.
# many minor changes until 6.55
#6.56 : hot-text for log file read from descript.ion
#       label for log chapter optionnaly read from descript.ion
#6.57: error handling when thumbnail corrupted
#6.58: bug in index without pics: <a name=... missings

sub init_config_help
  {
  my $config_help=$_[0];
  
  $config_help->{ThumbnailSurface}='Surface (in square pixels) of the created thumbnails.';
  $config_help->{MainDir}=         'Directory where the album is rooted';
  $config_help->{TitrePrincipal}=  'Name of the album: will appear in the title and in the window bar.';
  $config_help->{Tailer}=          'Text that will appear at the bottom of each page (HTML code)';
  $config_help->{Height}= 'Height of the <IMG> used in the <imageFileName.ext>.html';
  $config_help->{NbCol}=           'Nb of col of thumbnails in the index';
  $config_help->{FontFace}=        'Font name of the text';
  $config_help->{Language}=        'Language of the album (navigational elements)';
  $config_help->{Location}=        'Geographic location of the author or album';
  $config_help->{META_author}=	'Unqualified author\'s name';
  $config_help->{META_description}='A short, plain language description of the document';
  $config_help->{META_distribution}='Distribution conditions';
  $config_help->{META_keywords}='Keywords used by search engines to index your document';
  $config_help->{META_ownership}='Author in the copyrights\' view';
  $config_help->{META_generator}='Name and version number of the publishing tool';
  $config_help->{BODY_bgcolor}=     'background color';
  $config_help->{BODY_text}=	'color of text';
  $config_help->{BODY_link}=	'color of links';
  $config_help->{BODY_vlink}=	'color of visited links';
  $config_help->{BODY_alink}=	'color of active links (when you click or focus it)';
  $config_help->{BODY_background}= 'image of background';
  $config_help->{remote_host}='host of server for ftp transfer';
  $config_help->{remote_user}='username for ftp transfer';
  $config_help->{remote_root}='directory on ftp server';
  $config_help->{remote_pwd}='password for ftp tranfer, may be crypted';
  $config_help->{url}='Public URL of the album on server (used by the indexer)';

  }

#usage: get_config_default_set (\%ConfigTable, thumbnail_size, default_language)
sub get_config_default_set
  {
  my $nbparam=3; my $funcname='get_config_default_set';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $defaults=$_[0];
  my $default_thumbnail_size=$_[1];
  my $default_language=$_[2];

  my $hostname=hostname();
  $defaults->{'ThumbnailSurface'}  =defined($default_thumbnail_size)?$default_thumbnail_size:40000 ;
  $defaults->{'MainDir'}  ='';
  $defaults->{'TitrePrincipal'}  ='';

  $defaults->{'Tailer'}  ="File created $StampDate with software <a href=\"http://www.dunwich.org/soft/#albagtor\">\$generator</a> version \$STD_Version, last update \$StampDate from $hostname.";
  $defaults->{'Location'}  ='the third from the Sun';


  $defaults->{'Height'}=400 ;
  $defaults->{'NbCol'}=2 ;
  $defaults->{'FontFace'}  ='Lucida sans MS';

  $defaults->{'Language'}  =defined($default_language)? $default_language:'us';

  $defaults->{'META_author'}  ='';
  $defaults->{'META_description'}  ='Part of photo album';
  $defaults->{'META_distribution'}  ='private, limited to friends and relatives';
  $defaults->{'META_keywords'}  ='';
  $defaults->{'META_ownership'}  ='';
  $defaults->{'META_generator'}  ='$generator';

  $defaults->{'BODY_bgcolor'}='white';
  $defaults->{'BODY_text'}   ='black';
  $defaults->{'BODY_link'}   ='blue';
  $defaults->{'BODY_vlink'}  ='purple';
  $defaults->{'BODY_alink'}  ='red';
  $defaults->{'BODY_background'}  ='';
  
  $defaults->{'remote_host'}  ='';
  $defaults->{'remote_user'}  ='';
  $defaults->{'remote_root'}  ='';
  $defaults->{'remote_pwd'}  ='';

  $defaults->{'url'}  ='';

  return 1;
}

#doc of the line-command version
sub OnlineDoc_line_usage
  {
  my $prodline=$Guts{guts_product_name_line_cmd};
  my $usage =
"Usage 1: $prodline [-wsTR] -f Config_file_path [-t new_chapter] [-S default_surface] [ -F crypt_key]
Usage 2: $prodline [-wsTR] -I photos_path [-t new_chapter] [-S default_surface]
Usage 3: $prodline -i [-s] [-H HTML_index_file] [--] list_of_album_masks...
Usage 4: $prodline [-h|-v| {-P package_level}]\n";
  return $usage;
  }

#Will return the list of files that are required to package the product
sub OnlineDoc_package
  {
  my $level=$_[0];

  my @package_list=@{ $Guts{guts_package_list} } ;

  my $str='';
  if ($level == 1)
    {
    $str="$Guts{guts_product_lib}\n";
    foreach my $scriptid (@package_list) { $str = "$str$Guts{$scriptid}\n"; }
    }
  elsif ($level == 2)
    {
    $str="$Guts{guts_product_lib}\t$Guts{guts_lib_version}\n";

    my $X_pwd=cwd();
            #just test :
    chdir ($X_pwd) || return set_error_4p($MEID, 4605,"Unable to root itself on current directory");
    chdir($Guts{guts_script_dir})  || return set_error_4p($MEID, 4606,"Unable to cd the script directory");

    foreach my $scriptid (@package_list)
      {   
      my $v=`perl $Guts{$scriptid} -v`;
      $v =~ s!^.*/!! ;   # remove lib version (display format ' 6.5/1.0')
      $str = "$str$Guts{$scriptid}\t".$v ; 
      }
    chdir ($X_pwd) || return set_error_4p($MEID, 4607,"Unable to root back to current directory");
    }
  else
    { return set_error_4p($MEID, 3542, "Unknown package level. Should be 1 or 2"); }
  return $str;
  }

sub OnlineDoc_line
  {
  my ($ftp_script, $default_chapter, $prodline, $product, $ref, $log, $album, $tn, $RDIR_FN, $I1AG_FN, $ATAG_FN, $ITAG_FN, $ITNG_FN)=
     ($Guts{guts_ftp_script}, $Guts{guts_default_chapter}, $Guts{guts_product_name_line_cmd}, $Guts{guts_product_name}, $Guts{guts_REF_PATH}, $Guts{guts_LOG_PATH}, $Guts{guts_ALBUM_PATH}, $Guts{guts_TN_PATH}, $Guts{guts_RDIR_FN}, $Guts{guts_I1AG_FN}, $Guts{guts_ATAG_FN}, $Guts{guts_ITAG_FN}, $Guts{guts_ITNG_FN});


  my $line_options="<H2>Usage</H2>\n".
  OnlineDoc_line_usage().
"
  Usage 1: create/update album according to specification in file Config_file_path
  Usage 2: create/update album with default value using pictures in photos_path (MainDir/$ref).
  Usage 3: update/create index based on a list of album files designated by list_of_album_masks
  Usage 4: displays online doc, version number or package list.

<H2>Options</H2>
    -f: usage 1, mandatory. Specify the config file .
    
    -t: usage 1 & 2, optional. With this option, all orphean picture (pictures without thumbnails)  will have a thumbnail created in the chapter new_chapter, which will be created if necessary. See also option -S.
    
    -T: usage 1 & 2, optional. Force $product to rebuild every existing thumbnail. This option becomes handy after you made major editing on your pictures collection (red-eye reduction, cropping...). See also option -S. 
    
    -S: usage 1 & 2, optional. Whether missing or reconstructed (see option -T and -t), the thumbnails created by $product will have a constant surface, as explained in the main documentation. When this surface is not specified in a configuration file, $product will use the value specified in option -S. Note that if the surface is specified in the configuration file, the -S option does not override it (only for usage 1).
    
    -R: usage 1 & 2, optional: remove (delete) all orphean thumbnails (thumbnails for which there is no matching picture). Combine this option with -t, chapter by chapter, after you made some major file renames in your pictures collection.

    -I: usage 2, mandatory. Specify the photo directory. The main directory will be the parent of the photo directory, it is thus required that the photo directoy should be named like MainDir/$ref. Thumbnail directories will be created if missing with name according to option -t or '$default_chapter' if not specified.
    
    -H: usage 3: specify the file to edit or create to construct the index. If not specified, file will be STDOUT.

    -w: use wrap mode when updating the HTML code of the log files.	  

    -W: set to verbose warning mode. If you use logs combines with this option, $product will complain for every picture present in $ref but not referenced in the log.

    -s: set to silent mode: suppress info, display only warnings and errors

    -F: usage 1, optional. Specify the crypt key to use to decode the password for FTP transfer.

    -P: usage 4, optional. $product will diplay package information depending on the level. 1: list of mandatory files to be included in the package for shipment; 2: version of each file.
";
  return $line_options;
  }

sub get_List_defined_languages
  {
  my $str_List_defined_languages='';
  foreach my $l (@Defined_languages)
    {
    if (length($str_List_defined_languages) == 0)
      { $str_List_defined_languages="$l"  ; }
    else  
      { $str_List_defined_languages="$str_List_defined_languages, $l"  ; }
    }
  return $str_List_defined_languages ;
  }

#The doc is returned
sub OnlineDoc_main
  {
  
  my ($sub_Caller_Version, $sub_Caller_Script)=($_[0], $_[1]) ;

  my ($ftp_script, $product, $ref, $log, $album, $tn, $RDIR_FN, $I1AG_FN, $ATAG_FN, $ITAG_FN, $ITNG_FN)=
  ($Guts{guts_ftp_script}, $Guts{guts_product_name}, $Guts{guts_REF_PATH}, $Guts{guts_LOG_PATH}, $Guts{guts_ALBUM_PATH}, $Guts{guts_TN_PATH}, $Guts{guts_RDIR_FN}, $Guts{guts_I1AG_FN}, $Guts{guts_ATAG_FN}, $Guts{guts_ITAG_FN}, $Guts{guts_ITNG_FN});

  my %config_help;

  init_config_help(\%config_help);
  
  my $tn_pad=pack("A".length($tn)," ");

  my $str_List_defined_languages=get_List_defined_languages();

  my $strProduct_doc=
"<H1>Introduction</H1>
<H2>Product overview</H2>
	$product creates a HTML photo album based on a directory containing photo files.
The script can create a photo album based solely on the directory of photo.
In order to be able to have customized album, the script will use the following:
  i1 - directory containing the pictures *MANDATORY*
  i2 - indexes of legends on ACDSee format 
  i3 - configuration set
  i4 - list of labels to separate your album into chapters
  i5 - extra HTML files to be included in the album (called 'logs')

Only i1 is mandatory. It is required that the pictures-directory should be called $ref. It's parent directory is called \$MainDir (the 'main directory').

<H2>Album structure Overview</H2>
The album will have the following structure:

       \$MainDir-+-$album # will contain the HTML tree of the album  
                |
                +-$ref   # contains the pictures
                |
                +-$tn". "----+-chapter1    # will contain the thumbnails
                | $tn_pad    |
                | $tn_pad    +-chapter2
                |
                +-$log   # contains the extra files (i5)

  Once you created your thumbnails, you will put them in specific chapter directories to organise your album.

<H1>Detailed album structure</H1>
    <H2></H2>* $album
      Contains the HTML tree of the album. Will be created if missing. Do not put any extra files on it (if you want extra files, see $log below).

    <H2></H2>* $ref
      Contains the pictures full-size (i1) and the index of legend (i2).
      This directory is mandatory
      The pictures should be as following:
        format *.gif, *.jpg or *.jpeg
        no file called header.*
        no blank in filenames
      The index of legend should be as following:
        name: 'descript.ion'
        format: ACDSee format:
          one line per picture
          each line formated as following: 'filename<blank>legend'
          legend is HTML coded
    <H2></H2>* $tn
      Contains the chapters and the list of labels (i4)
      Each sub-directory of $tn is a chapter of the album.
      To have your pictures appear in the album, you will put their thumbnails in the proper chapter sub-directory as following:
	$tn/chapter1/tn_<imageFileName.ext>
	where <imageFileName.ext> matches an existing pictures from $ref.
        The name of the chapters as they appear in the album are in the list of label as following:
        filename is 'descript.ion' (on directory $tn)
        format: ACDSee format:
          one line per chapter
          each line formated as following: 'chapter-dirname<blank>chapter name'
          chapter name is HTML coded
        The chapter-dirname will be used if chapter name is not defined
      The chapter will be ordered by chapter-dirname
      If this directories are missing, your album will be empty. However, with proper options or command, you can force the $product to create a default chapter and all thumbnails to initialize your album.

    <H2></H2>* $log
      Contains extra HTML files (called 'logs') and other documents. Use this directory to add data in your album that you will not embed with the photos.
      The label to be used for the log section can be customized in the ACDSee file of the main directory
      All logs will be included in the album by means of a list of links in the section 'logs' of the album, hot-text will be read from the $log ACDSee file (filename if not defined).

      The content of the logs will be scanned and each tag <IMG> sourcing to pictures of the album will be normalized:
        sourcing will be set to the thumbnail
        propery ALT will contain the legend (converted as text)
        propery HEIGHT and WIDTH will be set
        image will be upgraded with link to the page of the picture
      If you wish to include non-HTML documents (AVI, sound...), you have to write a HTML log that will link explicitely to them.

  <H2></H2>More details:
    $product will create an album in the subdir $album under \$MainDir. During the process, the existing directory $album will be deleted (deltree), any existing files you may have drop here will be lost (the deltree will be executed in the 'cleaning' phase, after creation of a new album including the untouched files detected by the dirty-file detection system, see below).
    $product will create:
      - three main indexes under $album
        - $ATAG_FN: list of chapters (AT)
        - $ITAG_FN: list of chapters including display of all thumbnails by chapter (ITAG)
        - $ATAG_FN: list of chapters including list of all pictures (legend only) by chapter (ITNG)
      - one sub-directory for each chapter (same name as the chapter-dirname from $tn) where each chapter will be rooted. Each sub-directory will contain:
        - $I1AG_FN: list of pictures with display of thumbnails (I1AG)
        - <imageFileName.ext>.html for each picture: one HTML page with display of the picture (size limited by configuration), sourcing to the picture from $ref, legend from the index.
    In any cases, blanks in file or directory names are not supported, except for \$MainDir.
    In the album, all links will be converted as lowercase. If you use a case-sensitive platform, we recommand you set all your file and dir names to lowercase (this includes your http server if you publish your album).

  <H2></H2>Sound files:
    $product can embed sound files in your album in some extent. This feature is supported as following. In the $ref directory, if there is a sound file with the same name as a picture file (example: elephant.jpg and elephant.wav), then the comment of the said picture will be extended with the sound file (as link) plus it's comment if any -from ACDSee file). 
        
<H1>Configuration</H1>
  <H2></H2>Configuration set (i3)
    The appearance of the album will be customized by the configuration set.
    The configuration set is a file with the following format:
      one line per parameter
      format of line is: 'parameter =value'
      parameter name is case-sensitive
      parameter will be set to '' if 'value' is empty
      unset parameters will be replaced by default value 
      leading blanks allowed
      empty lines allowed
      blanks before '=' allowed
      no blanks after '='
      commented lines start by '#'
      unknown parameters are ignored
      
  <H2></H2>Configuration parameters overview


      Here are the items of the album file:
MainDir  : $config_help{MainDir}
Tailer   : $config_help{Tailer} 
NbCol    : $config_help{NbCol} 
FontFace : $config_help{FontFace}
Language : $config_help{Language} (see below)
Location : $config_help{Location} (see substitution below)
Height   : $config_help{Height}
ThumbnailSurface : $config_help{ThumbnailSurface}
TitrePrincipal   : $config_help{TitrePrincipal}

  The following are the meta tags used in the HTML file.
META_author       : $config_help{META_author}
META_description  : $config_help{META_description}
META_distribution : $config_help{META_distribution}
META_keywords     : $config_help{META_keywords}
META_ownership    : $config_help{META_ownership}
META_generator    : $config_help{META_generator}

  The followings are the properties of the BODY tag
BODY_bgcolor	: $config_help{BODY_bgcolor}
BODY_text	: $config_help{BODY_text}
BODY_link	: $config_help{BODY_link}
BODY_vlink	: $config_help{BODY_vlink}
BODY_alink	: $config_help{BODY_alink}
BODY_background : $config_help{BODY_background}

  The following are used for the automatic synchronization.
  Please refer to the section 'FTP transfer' below and to the doc of $ftp_script.
remote_host : $config_help{remote_host}
remote_user : $config_help{remote_user}
remote_root : $config_help{remote_root}
remote_pwd  : $config_help{remote_pwd} (see below)

  Extra remarks about configuration follows:
  
<H2></H2>* Language configuration parameter
	List of supported language: $str_List_defined_languages

<H2></H2>* Height configuration parameter
	Each photo page <imageFileName.ext>.html displays the matching picture from $ref with tag IMG with this specific height. The witdh will be set accordingly. If the height of the source is lesser than this parameter, the picture will keep its actual size.

<H2></H2>* ThumbnailSurface configuration parameter
	When created by $product, the thumbnail will be created with this constant surface, so that the global appearance will be sweet for the eye. Example with 40000: if your picture is portrait format 4/3, then the thumbnail\'s size will be 173 x 231 (same format but with surface approx to 40000). The same picture in landscape will be 231 x 173. Another thumbnail with format 16/9 will display as 267x150.
  These three will have different height and size, but constant surface. 
  This only applies when you let $product create (or re-create) the thumbnails, with proper options or command. On default behavior, $product does not recreates the existing thumbnails and displays error messages on missing thumbnails.

<H2></H2>* remote_pwd configuration parameter
if you put the uncrypted password here, be carefull that this file will not be included in the transfer to the server in which case your ftp password would become publicly available by http. To prevent that, you can either put this file outside the \$MainDir, or you can crypt it. See section 'FTP Transfer'.

<H2>Use variables in configuration</H2>
  On creation of the album, the values of the configuration set will be expanded as following:
    \$Location will be replaced by value of parameter Location
    \$generator will be replaced by the name of the product
    \$STD_Version will be replaced by product name
    \$ENV{var} will be replaced by value of \$var (where \$var is an environment variable)

<H2>Default values of configuration</H2>
  The default values of the following can be specified by option on the command lines: ThumbnailSurface, ThumbnailSurface
    
<H1>Album index creation</H1>
    In order to help the user to manage his collection of album when it increases, 
    $product comes with an album indexer that will creates for you list of albums with statistics and addresses.
    The indexer will have different behavior depending it is exectued from the graphical interface and the command line interface. The following apply to all versions.
    With proper options or command, $product will scan a list of specified album files to compute different kind of indexes.
    The list of files included in the scope of the index is specified by a list of mask.
    For example, 'china-*.alb thai-*.alb' is a valid list of masks. The corresponding files will be scanned for relevant information regarding the indexes to construct.
    The index will be written in an HTML file (that may be STDOUT).

    The detailed index will indicate:
      Pictures: number, volume
      Volume of album (pictures + HTML)
      URL of album (when available)
      Description of the album (extracted from the description of the main header image)

    The three supported index have the following tag-ID:
      album_index_simple (AIS)
        list of albums with links to albums on remote server. No details.
      album_detailed_server (ADS)
        detailed list of albums with HTML link to albums on server. Use this one for publication.
      album_detailed_local (ADL)
        detailed list of albums with HTML link to local album files. Use this one for your internal use only

      album_index_mapping (AIM)
       list of albums with internal links to the album items in the index file. This one is suppoes to be used followed by another one.

      index_by_server (IBS)
       list of albums grouped by server, with display of server stat. Use this to keep track of your server layout and occupancies.

    If the file does not previously exist (or is STDOUT), then, standard index are created in an new HTML file, that will contain AIS and ADS.
    Otherwise, the existing index in the HTML file (located by their tag-ID, the 1st of each only) will be updated. If there is none, no index will be computed.
    Example: to insert an AIS index in an existing HTML file, write the following tag where you want the index to be inserted: '<DIV id=\"album_index_simple\"></DIV>'. When you feed your file to $product, all HTML code within this DIV tag will be replaced by the index.

    The expansion of the list of mask will be different depending on the interface and on the platform:
      command-line interface
        Expansion will be performed by the shell. For M\$-Windows based platform, you need to set the Wild.pm option. See installation notes of $product. 
        You can use environment variables; relative and absolute path.
      graphical interface
        Expansion will be performed by the standard perl 'glob' (same as /bin/csh). 
        You can use environment variables \${VAR} will be replaced by the value of VAR
        Backslash (\\) will be threated as escape characters.
        If you are a M\$-Windows user, replace '\\' by '/' in the path to expand sub-directories. The system will detect that 'c:\\' (example) is a root
        The graphical interface can let you pre-view the list of files selected by the masks


<H1>Dirty-page detection</H1>
  The dirty page detection is the system that will let you or another process detect which pages has been modified after album update. These files are called dirty files (because they have been touched).
  When the album gets bigger, the number of files increases. If you publish the album on a http server remote server synchronized by ftp, the transfer time will increase. It is thus worthwile to limite the transfer only to the modified files. The dirty-page detection will help you with that regard.
  The followings are implemented:
   * $product is able to detect when you perform an update of an existing album (as opposed to creation of a new album), the pages that do not bear modification are left untouched. The pages that are not part of the album any more are removed (including any extra unknown file or directory).
   * stampdates, version number, location... are only set on dirty pages.
   * An invisible character-padding will randomize the size of the file.

  These three features combined will garantee that a dirty file will always have a different file size (than it's own size before update), even if (for example) the modification is only changing one character 'a' to 'A'.   
  
  After album updates, the dirty files can thus be detected:
  	by their stampdate
  	by comparing their size versus their size before the update

<H1>FTP transfer</H1>
  If you want to send your album on a remote server (example for HTTP publication), you can use any FTP client. However, then you can make $product to do job by using another software developped by the author named $ftp_script.
  
  If $ftp_script is installed, and on proper options and command, $product will execute $ftp_script to connect by ftp to the remote server and synchronise the album, using the file-size as dirty-page detection system (providing you always transfer your files in binary mode).

  With $product combined with $ftp_script, you will only transfer the pages that where modified by the album update.
  
  The configuration file that $ftp_script uses is the same as the one used by $product: you will fill the thre 'remote_*' parameters. Password should be crypted, and will be decrypted by $ftp_script on connection time based on the key specified by the user on execution time.

  Please refer to the documentation of $ftp_script for details, specifcally the encryption/decryption system.

<H1>Line command</H1>
".
OnlineDoc_line() . 
"

<H1>Future upgrades</H1>
  Documentation related to indexer anf ftp synchronization requires review
  'Belphgor' bug
  crypt/decrypt should be available in graphic mode from the albagraph front-end

<H1>Final statement</H1>

  The author hopes you enjoyed reading it's documentation and that you will enjoy much more using his product.

  $Guts{guts_copyright_notice}

  Always make sure you use the last version which is available at http://www.dunwich.org/soft
  Bug reports and feature requests should be sent to author at baptiste\@dunwich.org.
  Refer to http://www.dunwich.org for more contact information about the author.
  
  Product $product, Library $Guts{guts_product_lib} version $Guts{guts_lib_version}
  Script $sub_Caller_Script version $sub_Caller_Version
";


  
  return $strProduct_doc ;  
  } 


sub OnlineDoc
  {
  my $nbparam=1; my $funcname='OnlineDoc';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";
  my ($sub_Caller_Version)=($_[0]) ;
  
  return OnlineDoc_main($sub_Caller_Version, $Guts{$Guts{calling_script_ID}});
  } 

  
sub set_mode_silent
  {
  $ModeSilence=$_[0];
  }

sub get_guts
  {
  return $Guts{$_[0]};
  }
  

  
  
sub create_thumbnail
  {
  ( $#_ +1 == 3 ) || die "Compile error: create_thumbnail expects 3 parameters (you gave $#_ +1).\n";
	my $img_src =$_[0];
	my $img_dest=$_[1];
	my $Surf=$_[2];

  if ( ! -r $img_src ) { print STDERR "Unable to read file $img_src\n" ; return undef ; }

	my $image=Image::Magick->new;
	my $r=$image->Read($img_src) ; print STDERR "$r\n" if ($r ne '' );
	my ($h, $w, $S)=$image->Get('height','width', 'filesize');
  defined $h || return ; 
	my ($h2, $w2, $S2);
        if ( $Surf >= $h * $w ) #the picture is already smaller than the thumbnail...
          {
	  ($h2, $w2, $S2)=($h, $w, $S);
	  copy($img_src,$img_dest);
	  }
	else
	  {
	  my $format_vert= $h / $w ;
	  $w2 = sqrt($Surf  / $format_vert ); $h2= $w2 * $format_vert ;
          $r=$image->Resize(height=>$h2,width=>$w2); print STDERR "$r\n" if ($r ne '' );
	  ($h2, $w2, $S2)=$image->Get('height','width', 'filesize');
          $r=$image->Write($img_dest) ; print STDERR "$r\n" if ($r ne '' ); 
	  }
	( -f $img_dest ) || print STDERR "Uncreated $img_dest.\n";
  return ($h, $w, $S, $h2, $w2, $S2);	
  }
  
sub deltree
  {
  my $D=$_[0] ;
  return -1 if (! -d $D) ;

  #Le code ci-dessous fait du deltree  
  find(\&rmfile, $D);
  @cumuldirlist = () ;
  find(\&cumuldirlist, $D);
  foreach my $Di (@cumuldirlist)
    { rmdir $Di ; }
  rmdir $D if ( -d $D );
  print ("Warning 21011859: unable to remove $D: $!\n")  if ( -d $D );
  return (! -d $D) ;
  }

#compute the size of a tree *except* any subdirecytory called ref
sub treesize_wanted_noref
 {
 if ( -f $File::Find::name && lc(basename($File::Find::dir)) ne 'ref')
  {
  my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size, $atime,$mtime,$ctime,$blksize,$blocks)
    = stat($File::Find::name );
   $TreeSize += $size;
  }
 } 

#compute the size of a tree *except* any subdirecytory called ref
sub treesize_noref
  {
  my $D=$_[0] ;
  return undef if (! -d $D) ;

  my $D_Abs;
  my $CurDir = cwd ();
  chdir($D);
  $D_Abs = cwd();
  chdir $CurDir;

  $TreeSize=0;
  find(\&treesize_wanted_noref, $D_Abs);
  return $TreeSize;
  }

sub smart_update_old_new_album 
  {
  if ($File::Find::topdir eq $File::Find::name) { mkdir $File_Find_Data_Struct{'ALBUM_DIR'} ; return 1 };
  
  my $subpath = substr($File::Find::name,length($File::Find::topdir)+1) ;
  my $oldfile=File::Spec->catfile($File_Find_Data_Struct{'ALBUM_DIR_OLD'},$subpath);
  my $newfile=File::Spec->catfile($File_Find_Data_Struct{'ALBUM_DIR_NEW'},$subpath);
  my $finalfile=File::Spec->catfile($File_Find_Data_Struct{'ALBUM_DIR'},$subpath);

  if ( -d $newfile ) # Is a directory: create it.
    { mkdir $finalfile ; return 1 ; }

  $File_Find_Data_Struct{'count_total'}++;

  if ( ! -f $oldfile || significant_diff ($oldfile, $newfile) )
    {
    unlink $oldfile if ( -f $oldfile );
    move ($newfile, $finalfile);
    $File_Find_Data_Struct{'count_touched'}++;
    }
  else
    {
    move ($oldfile, $finalfile);
    }
  }

sub significant_diff
  {
  open(LEFT, "< $_[0]") || die "Error 2349 - unable to open $_[0]: $!";
  open(RIGHT, "< $_[1]") || die "Error 2349b - unable to open $_[1]: $!";
  my $diff=0 ;
  findiff: while (<LEFT>)
    {
    my $right;
    if (eof(RIGHT)) { $diff=1 ; last findiff ; }
    $right= readline *RIGHT ;
    if ( $right ne $_ ) 
      {
      if ( ! ( $right =~ m/<!--stampdate-->/ && m/<!--stampdate-->/ )  &&
           ! ( $right =~ m/<!--location-->/  && m/<!--location-->/ )  &&
           ! ( $right =~ m/<!--STD_Version-->/  && m/<!--STD_Version-->/ )  &&
           ! ( $right =~ m/marker=3/         && m/marker=3/ )    )
        { $diff=1 ; last findiff ;  }
      }
    }

  close(LEFT); 
  close(RIGHT); 
  return $diff ;
  }
  
#sub get_image_stats {
#  ( $#_ +1 == 1 ) || die "Compile error: get_image_stats expects 1 parameters (you gave $#_ +1).\n";
#	my $img_src =$_[0];
#
#  if ( ! -r $img_src ) { print STDERR "Unable to read file $img_src\n" ; return undef ; }
#
#	my $image=Image::Magick->new;
#	$image->Read($img_src) ;
#	return $image->Get('width', 'height', 'filesize');
#}

#####################################################################
#####                   Override imageMagick                   #####
#####################################################################
sub get_image_stats 
  {

  my($height,$width);
  my ($image) ;
  my ($file) = @_;

  my ($filetype) = &get_file_type($file);

  my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
       $atime,$mtime,$ctime,$blksize,$blocks)
           = stat($file);
           
  open (ORIGINAL,$file) || return set_error_4p($MEID, 1821,"Could not open $file for reading: $!");

  binmode ORIGINAL, ":raw" ;
  
  if ($filetype eq 'jpg') 
    {
    ($width,$height)= &jpegSize2(\*ORIGINAL);
    }
  elsif ($filetype eq 'gif') 
    {
    $image=<ORIGINAL>;
    ($width,$height) = &gifsize($image);
#    ($width,$height) = &gifsize(\*ORIGINAL);  #this one does not work
    }
 
#       if ($filetype eq 'png') {  # A quick hack to read PNG 
#               $image = `pngtopnm $file`;      
#               if (length ($image) == 0) {
#                       print STDERR "$file does not seems to be PNG.\n";
#                       return;
#               }
#               ($width,$height) = &pnmsize($image);
#       } else { # Let 'anytopnm' have a shot at it. "Do you feel lucky, punk?"
#               $image = `anytopnm $file`;
#               if (length ($image) == 0) {
##                      print STDERR "Could not determine type of $file. Skipping\n";
#                       return;
#               }
#               ($width,$height) = &pnmsize($image);
#       }

  else
    {
    set_error_4p($MEID, 1822,"Unable to process this type of $file. Skipping");
    }


  close(ORIGINAL);
  return set_error_4p($MEID, 1823,"Could not determine height or width of $file. ".get_error(0)." -> Skipping\n")  if (! ($height && $width)) ;
  return ($width,$height,$size);
  }

        ######################################################################
        # Guess the file type                                                #
        ######################################################################
sub get_file_type {

        my ($file) = @_;

        my ($filetype) = '';

        if ($file =~ m/\.(pjpeg|jpg|pjpg|jpeg)$/i) {
                $filetype = 'jpg';

        } elsif ($file =~ m/\.gif$/i) {
                $filetype = 'gif';

        } elsif ($file =~ m/\.(png)$/i) {
                $filetype = 'png';

        } else {
                $filetype = 'unknown';
        }

        return ($filetype);
}
        ########################################################################
        # Determines the size of a gif                                        #
        ########################################################################
sub gifsize {
        my($GIF) = @_;

        my ($type,$a,$b,$c,$d,$s,$width,$height);
  
        $type=substr($GIF,0,6);
        if(!($type =~ m/GIF8[7,9]a/) || (length($s=substr($GIF, 6, 4)) != 4) ){
                return;
        }
        ($a,$b,$c,$d)=unpack("C"x4,$s);
        $width= $b<<8|$a;
        $height= $d<<8|$c;
        return ($width,$height);
}

        ########################################################################
        # Determines the size of a jpeg                                        #
        ########################################################################
sub jpegsize {

  my($JPEG) = @_;

  my($count) = 2;
  my($length)= length($JPEG);
  my($ch)    = "";
  my ($c1,$c2,$a,$b,$c,$d,$width,$height);

  while (($ch ne "\xDA") && ($count<$length)) {
    # Find next marker (JPEG markers begin with 0xFF)
    while (($ch ne "\xFF") && ($count < $length)) {
        $ch=substr($JPEG,$count,1); 
        $count++;
    }
    # JPEG markers can be padded with unlimited 0xFF's
    while (($ch eq "\xFF") && ($count<$length)) {
        $ch=substr($JPEG,$count,1); 
        $count++;
    }
    # Now, $ch contains the value of the marker.
    print ("Marker value on $count ", int($count/16),".", $count-int($count/16)*16, "\n");
    if ((ord($ch) >= 0xC0) && (ord($ch) <= 0xC3)) {
        $count+=3;
        ($a,$b,$c,$d)=unpack("C"x4,substr($JPEG,$count,4));
        $width=$c<<8|$d;
        $height=$a<<8|$b;
        return($width,$height);
    } else {
      # We **MUST** skip variables, since FF's within variable names are
      # NOT valid JPEG markers
        ($c1,$c2)= unpack("C"x2,substr($JPEG,$count,2));
        $count += $c1<<8|$c2;
    }
  }   
}

sub jpegSize2 
  {
  my ($JPEG) = shift ;
#  my ($JPEG) = @_;
  my ($done) = 0;
  my ($size) = "";
  my ($c1, $c2, $ch, $junk, $s, $a, $b, $c, $d, $length) ;
  $ch = 0 ;
  
  read($JPEG, $c1, 1); read($JPEG, $c2, 1);
  return set_error_4p($MEID, 1815,"This is not a JPEG!") if( !((ord($c1) == 0xFF) && (ord($c2) == 0xD8)));
  while (ord($ch) != 0xDA && !$done) {
    # Find next marker (JPEG markers begin with 0xFF)
    # This can hang the program!!
    while (ord($ch) != 0xFF) {  read($JPEG, $ch, 1); }
    # JPEG markers can be padded with unlimited 0xFF's
    while (ord($ch) == 0xFF) { read($JPEG, $ch, 1); }
    # Now, $ch contains the value of the marker.
    if ((ord($ch) >= 0xC0) && (ord($ch) <= 0xC3)) {
      read ($JPEG, $junk, 3); read($JPEG, $s, 4);
      ($a,$b,$c,$d)=unpack("C"x4,$s);
      $size=join("", 'HEIGHT=',$a<<8|$b,' WIDTH=',$c<<8|$d );
      $done=1;
    } else {
      # We **MUST** skip variables, since FF's within variable names are
      # NOT valid JPEG markers
      read ($JPEG, $s, 2); 
      ($c1, $c2) = unpack("C"x2,$s); 
      $length = $c1<<8|$c2;
      if( ($length < 2) ){
        return set_error_4p($MEID, 1816,"Erroneous JPEG marker length") if( !((ord($c1) == 0xFF) && (ord($c2) == 0xD8)));
      } else {
        read($JPEG, $junk, $length-2);
      }
    }
  }
  return ($c<<8|$d, $a<<8|$b) ;
}


        ########################################################################
        # Determines the size of an anymap                                     #
        ########################################################################
sub pnmsize {
        my($pnm) = @_;

        my ($width,$height);

        ($width,$height)=$pnm=~m#^P\d+\s+(\d+)\s+(\d+)\s+\d+\s#ois;
        return ($width,$height) if ($width && $height);
}

######################################
# create_index_of_albums

# usage create_index_of_albums ($AlbumList, $HTML_index_page_in, $HTML_index_page_out, $homedir)
#   $AlbumList is ref to array
#   $HTML_index_page_in is string. File to be scanned. 
#     $HTML_index_page_in=='' => start with standard index
#   $HTML_index_page_out (string): file to write output. Can be the same file as the input file
#     $HTML_index_page_out='<STDOUT>' => write to STDOUT
#   $homedir: dir from where the albums are listed. Current dir if ''
sub create_index_of_albums
  {
  my $nbparam=4; my $funcname='create_index_of_albums';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $IndexList = $_[0];
  my @DirDeAlbum = @{ $IndexList } ;
  my $HtmlIndexPage = $_[1];
  my $HTML_index_page_out=$_[2] ;
  my $homedir=$_[3] ;

  my $f_ch_dir=0;
  my $X_pwd;
  $f_ch_dir=1 if ($homedir ne '') ;

#index_simple
#index_mapping
#detailed_server
#detailed_local

  return undef if ( ! defined ($IndexList) ||  ! defined ($HtmlIndexPage));

  if ($f_ch_dir)
    {
    $homedir =~ s/(\$\{([^}]+)\})/$ENV{$2}/g ;
    $X_pwd=cwd;
    chdir ($X_pwd) || return set_error_4p($MEID, 14049,"Unable to root itself on current directory");
    chdir ($homedir) || return set_error_4p($MEID, 14055,"Unable to cd to the specified directory '$homedir'");
    }
  

  my $html=HTML::TreeBuilder->new ;
  my ($index_simple, $index_mapping, $detailed_server, $detailed_local, $index_by_server, $index_by_server_table);
  print ("Scan ");

    
  if ( $HtmlIndexPage ne '' ) # we update an existing index
    {
    $html->store_comments(1);
    $html->parse_file($HtmlIndexPage);

#locate the indexes in each file
    $index_simple = $html->find_by_attribute('id', 'album_index_simple');
    $index_mapping = $html->find_by_attribute('id', 'album_index_mapping');
    $detailed_server = $html->find_by_attribute('id', 'album_detailed_server');
    $detailed_local = $html->find_by_attribute('id', 'album_detailed_local');
    $index_by_server = $html->find_by_attribute('id', 'index_by_server');

    $index_by_server_table = $html->find_by_attribute('id', 'index_by_server_table');

    #we located them, we will keep e ref to them in the tree. We can now delete their content before update
    $index_simple->delete_content() if ( defined $index_simple ) ;
    $index_mapping->delete_content() if ( defined $index_mapping ) ;
    $detailed_server->delete_content() if ( defined $detailed_server ) ;
    $detailed_local->delete_content() if ( defined $detailed_local ) ;
    $index_by_server->delete_content() if ( defined $index_by_server ) ;

    $index_by_server_table->delete_content() if ( defined $index_by_server_table ) ;
    }
  else
    {
    #We create a new index with these 2 items: album_index_simple and album_detailed_server
    $index_mapping=HTML::Element->new('div','id'=>'album_index_simple');
    $detailed_server=HTML::Element->new('div', 'id'=>'album_detailed_server');

    $html->push_content($index_mapping);
    $html->push_content($detailed_server);
    }

  my $ul_simple         =HTML::Element->new('ul');
  my $ul_mapping        =HTML::Element->new('ul');
  

  my $ul_server=HTML::Element->new('ul');
  my $ul_local =HTML::Element->new('ul');
  my $ul_by_server =HTML::Element->new('ul');
  my $table_by_server =HTML::Element->new('table', 'border'=>1);
  my $nbsp=decode_entities("&nbsp;");

  if ( defined $index_simple || defined $index_mapping || defined $detailed_server || defined $detailed_local 
       || defined $index_by_server) 
    #enter here only if there is some index to create
    {
    my (%AllALbumFiles, %AllServers);
    my (%alb_stat_ref_cumul_sizes, %alb_stat_ref_nb, %alb_stat_all_cumul_sizes, %alb_stat) ;
    
    print (" ". $#DirDeAlbum +1 . " albums." );
#    print (" $DirDeAlbum[0]\n" );

    foreach my $albumfile (sort(@DirDeAlbum))
      {
      print (".");

      my (%ConfTab);  # expanded
        {
         
        my (%ConfTabRestricted);
        config_file_read ($albumfile, \%ConfTabRestricted) || return undef;
        config_file_expand(\%ConfTabRestricted, \%ConfTab, 0) || return undef;
        }

      $AllALbumFiles{$albumfile}= { %ConfTab };


      my $MainDirThisOne = $ConfTab{'MainDir'};
      if (! defined ($MainDirThisOne) || $MainDirThisOne eq '' ) 
        {
        print STDERR "Warning: Album file $albumfile does not contain any MainDir\n";
        } 
      else
        {
        #Stat: combien de photos?
        $alb_stat_ref_nb{$albumfile}=0;
        my ($Stat_nb_de_photos, $Stat_sum_des_sizes_photos_MB)=(0,0);
        my $RefDirThisOne=File::Spec->catfile($MainDirThisOne,'ref');
        opendir (REF_DIR, $RefDirThisOne) || die "Error 2350 - unable to open $RefDirThisOne\n" ;
        my @FileListDeRefThisOne = readdir(REF_DIR) ;
        closedir(REF_DIR);
        foreach my $ref_file_name (@FileListDeRefThisOne)
          {
          if ( is_image($ref_file_name) )
            { $Stat_nb_de_photos++ ;}
          my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
              $atime,$mtime,$ctime,$blksize,$blocks)
               = stat(File::Spec->catfile($RefDirThisOne,$ref_file_name));
          $Stat_sum_des_sizes_photos_MB = $Stat_sum_des_sizes_photos_MB + $size ;
          }  

        $alb_stat_all_cumul_sizes{$albumfile}=treesize_noref($MainDirThisOne)+$Stat_sum_des_sizes_photos_MB;
        $alb_stat_ref_cumul_sizes{$albumfile}=$Stat_sum_des_sizes_photos_MB;
        $alb_stat_ref_nb{$albumfile}= $Stat_nb_de_photos ;
        $alb_stat{$albumfile}=1;
        }
      }
    print (" Scan: ");
    foreach my $albumfile (sort(@DirDeAlbum))
      {
      print (".");
      my (%ConfTab);
      %ConfTab= %{ $AllALbumFiles{$albumfile} }  ;

      my $MainDirThisOne = $ConfTab{'MainDir'};
  
    #Le tritre principal
      my @Titre_principal_HTML=ListLocalTreeBuilder ($ConfTab{'TitrePrincipal'}); 

      my ($url, $str_url, $str_url_local);

      if ( defined $ConfTab{'MainDir'} )
        { 
        $str_url_local=URI::file->new("$ConfTab{'MainDir'}/$Guts{guts_ALBUM_PATH}/$Guts{guts_ATAG_FN}","win32");
        }

      if ( defined ($ConfTab{'url'}) &&  $ConfTab{'url'} ne '' )
        { 
        $url = URI->new($ConfTab{'url'}); 
        $str_url=$url->as_string;
        }
      elsif ( defined ($ConfTab{'remote_host'}) && $ConfTab{'remote_host'} eq 'ftpperso.free.fr')
        { 
        $url=URI->new("http://$ConfTab{'remote_user'}.free.fr$ConfTab{'remote_root'}/$Guts{guts_ALBUM_PATH}"); 
        $str_url=$url->as_string;
        }
      else
        {
	$str_url=$albumfile ;
	}
      if( defined ($url) && defined ($url->host()))
	{
        $AllServers{$url->host()}=1 ;
        $AllALbumFiles{$albumfile}{'server'}= $url->host()  ;
	}
      else
        {
        $AllServers{'local'}=1 ;
        $AllALbumFiles{$albumfile}{'server'}= 'local' ;
	}
      
	#link to the album as local file (file://...)
      my $a_local=HTML::Element->new('a','href'=>$str_url_local);

	 #link to the album as fragment (href="#foobar")
      my $a_mapping=HTML::Element->new('a', 'href'=>'#'.basename($albumfile));

      my $a_name=HTML::Element->new('a','name'=>basename($albumfile));
      my ($a_simple, $a_server);

      if ( defined $url)
        { $a_simple=HTML::Element->new('a','href'=>$str_url); 
        $a_server=HTML::Element->new('a','href'=>$str_url); }
      else
        { $a_simple=HTML::Element->new('a','name'=>"no_link_to_".basename($str_url)); 
        $a_server=HTML::Element->new('a','href'=>"no_link_to_".basename($str_url)); }

      for my $a ($a_local, $a_mapping, $a_simple, $a_server)
        {$a->push_content((@Titre_principal_HTML, " ($str_url)"))}
  
      my $li_simple=HTML::Element->new('li');
      my $li_mapping=HTML::Element->new('li');
      my $li_server=HTML::Element->new('li');   
      my $li_local=HTML::Element->new('li');   

      $li_simple->push_content($a_simple); 
      $li_mapping->push_content($a_mapping); 

      $li_server->push_content($a_name,$a_server); 
      $li_local-> push_content($a_name,$a_local); 


      $ul_simple->push_content($li_simple);
      $ul_mapping->push_content($li_mapping);
      $ul_server->push_content($li_server);
      $ul_local->push_content($li_local);
 
  
      if ( defined $detailed_server || defined $detailed_local ) 
	{
    
      #Le blabla en tte de l'album est dans 
      #the descript.ion of the main dir contains the comment of the main header picture and the label to use for the log directory
        $DescriptionACD{'header.jpg'}=undef;
        insert_in_descriptionACD_hachoir (File::Spec->catfile($MainDirThisOne,'descript.ion') ,'filemode')  ; 


        my @bla_bla_du_header_HTML=ListLocalTreeBuilder ($DescriptionACD{'header.jpg'}); 


        my $Stat_sum_des_sizes_photos_MB = $alb_stat_ref_cumul_sizes{$albumfile} / 1024 / 1024 ;
        my $Stat_sum_des_sizes_all_MB = $alb_stat_all_cumul_sizes{$albumfile} / 1024 / 1024 ;

        my $Stat_sum_des_sizes_photos_B = $alb_stat_ref_cumul_sizes{$albumfile} ;
        my $Stat_sum_des_sizes_all_B = $alb_stat_all_cumul_sizes{$albumfile} ;
        
        
        
        my $Stat_nb_de_photos = $alb_stat_ref_nb{$albumfile} ;
        for my $li_i ($li_server, $li_local)
	  {
          $li_i->push_content(HTML::Element->new_from_lol(
            ['ul',
              ['li', "Nombre de photos: $Stat_nb_de_photos"],
              ['li', "Taille des photos: ", sprintf("%.1f${nbsp}MB (%d${nbsp}B)",$Stat_sum_des_sizes_photos_MB,$Stat_sum_des_sizes_photos_B)],
              ['li', "Taille totale: ", sprintf("%.1f${nbsp}MB (%d${nbsp}B)",$Stat_sum_des_sizes_all_MB,$Stat_sum_des_sizes_all_B)],
              ['li', "URL: ", 
                ['a', {'href',$str_url}, $str_url]
                ],
	      ['br']
            ] ));   }

        for my $li_i ($li_server, $li_local)
	  {
          $li_i->push_content( HTML::Element->new_from_lol(
          ['table', {'border', '1', 'width','90%'},
            ['tr',
    	      ['td', @bla_bla_du_header_HTML]
    	    ]
          ] 
          ));  }



        $ul_server->push_content($li_server);
        $ul_local->push_content($li_local);

	if ( defined $detailed_server)
          { $detailed_server->push_content($ul_server); }
	if ( defined $detailed_local )
          { $detailed_local->push_content($ul_local);}
	}
      $index_simple->push_content($ul_simple) if ( defined $index_simple ) ;
      $index_mapping->push_content($ul_mapping) if ( defined $index_mapping ) ;
      }
    ##
    #Faire des stats par server
    # On a une liste des servers:	    

    my $ul=HTML::Element->new('ul');
    $ul_by_server->push_content ($ul);
    foreach my $albumfile (sort(@DirDeAlbum))
      {
      if ((! defined ($alb_stat{$albumfile})) || ! defined ( $AllALbumFiles{$albumfile}->{'server'} ))
        {print STDERR "Warning: no server or no stat for $albumfile\n";}
      }
    print (" Write...");
    for my $server (sort(keys (%AllServers)))
      {

      my $li_b=HTML::Element->new_from_lol(['b', $server] );
      my $tr_b=HTML::Element->new_from_lol(['tr',['TD',['li',['b', "$server$nbsp"]]]]);

      my $li=HTML::Element->new('li'); $li->push_content($li_b);

      $ul->push_content ($li); 
      $table_by_server->push_content ($tr_b); 
      my $ul2=HTML::Element->new('ul');

      my $server_stat_ref_cumul_sizes=0;
      my $server_stat_ref_nb=0;
      foreach my $albumfile (sort(@DirDeAlbum))
        {
        if (defined ($alb_stat{$albumfile}) && defined ( $AllALbumFiles{$albumfile}->{'server'} ))
	  {
	  if ( $AllALbumFiles{$albumfile}->{'server'} eq $server )
	    {
	    $server_stat_ref_cumul_sizes = $server_stat_ref_cumul_sizes + $alb_stat_all_cumul_sizes{$albumfile} ;
	    $server_stat_ref_nb = $server_stat_ref_nb + $alb_stat_ref_nb{$albumfile} ;
	    my $li2=HTML::Element->new_from_lol(
              ['li', basename($albumfile), sprintf(" (%.1f${nbsp}MB, %d${nbsp}B, %d${nbsp}ph.)",$alb_stat_all_cumul_sizes{$albumfile}/1024/1024, $alb_stat_all_cumul_sizes{$albumfile}, $alb_stat_ref_nb{$albumfile})]
	      )	 ;
            my $tr2= HTML::Element->new_from_lol(
              ['tr',['TD', $nbsp,$nbsp,$nbsp,$nbsp,basename($albumfile)],['TD'],['TD'],
                    ['TD', sprintf("$nbsp%.1f${nbsp}MB$nbsp",$alb_stat_all_cumul_sizes{$albumfile}/1024/1024)],
                    ['TD', sprintf("$nbsp%d${nbsp}B$nbsp",$alb_stat_all_cumul_sizes{$albumfile})],
                    ['TD', sprintf("$nbsp%d${nbsp}ph.$nbsp", $alb_stat_ref_nb{$albumfile})]]
              )  ;
            $ul2->push_content ($li2);
            $table_by_server->push_content ($tr2);
	    }
	  }
	}
      $li_b->push_content (sprintf(" (%.1f${nbsp}MB, %d${nbsp}B, %d${nbsp}ph.)",$server_stat_ref_cumul_sizes/1024/1024, $server_stat_ref_cumul_sizes, $server_stat_ref_nb)); 
      $tr_b->push_content (['td',['b',sprintf("$nbsp%.1f${nbsp}MB$nbsp",$server_stat_ref_cumul_sizes/1024/1024)]],
                           ['td',['b',sprintf("$nbsp%d${nbsp}B$nbsp",$server_stat_ref_cumul_sizes)]],['TD'],['TD'],
                           ['td',['b',sprintf("$nbsp%d${nbsp}ph.$nbsp",$server_stat_ref_nb)]]); 
      $li->push_content ($ul2); 
      }
    $index_by_server->push_content($ul_by_server) if ( defined $index_by_server ) ;
    $index_by_server_table->push_content($table_by_server) if ( defined $index_by_server_table ) ;
    }


  if ( ! $HTML_index_page_out ne '<STDOUT>' )
    {
    open (OUT, "> $HTML_index_page_out") || set_error_4p($MEID, 12738,"Unable to write index in '$HTML_index_page_out'");
    print OUT Workaround_unicode_html($html->as_HTML(undef,"  "));
    close OUT  || set_error_4p($MEID, 12739,"Unable to close index in '$HTML_index_page_out'");
    }
  else
    {print Workaround_unicode_html($html->as_HTML(undef,"  "));}
   
    print ("Done\n");
  if ($f_ch_dir)
    {
    chdir ($X_pwd) || return set_error_4p($MEID, 14100,"Unable to root back to current directory");
    }

  return 1 ;
  }


        ########################################################################



sub cumuldirlist
 {
 my $dir = cwd ;
 @cumuldirlist = (@cumuldirlist, File::Spec->catfile($dir,$_));
 } 

sub transfolink
  {
  my $string = $_[0] ;
  $string =~ s/\\/\// ;
  return lc($string);
  }

sub is_image
  {
  my $path=lc($_[0]);
  ( $path =~ m/\.jpe?g$/i || $path =~ m/\.gif$/i ) && return 1 ;
  }

sub print_msg
  {
  my ($msg, $level, $OutHandler) = ('', 0, *STDOUT);
  if ($#_ + 1 ge 1)
    {$msg=$_[0];}
  if ($#_ + 1 ge 2)
    {$level=$_[1];}
  if ($#_ + 1 ge 3)
    {$OutHandler=$_[2];}

  if ( ! $ModeSilence || $level gt 0 )
    { print $OutHandler $msg; }
  }

#####################################################################
#####             Definition of language bundles                #####
#####################################################################

#Will create all the lanhuage bundles and set the current language to the one specified
# return undef if failed
#usage init_bundles(language);
sub init_bundles
  {
  my $nbparam=1; my $funcname='init_bundles';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $cur_lang=$_[0];
  my ($language_fr, $language_us); 

  $language_us={}; $languages{'us'}=$language_us;
  $language_fr={}; $languages{'fr'}=$language_fr;

  if ( ! defined ($languages{$cur_lang} ) )
    {
    return set_error ("$MEID-2230 - Unknown language '$cur_lang'.");
    }
  $language_bundle=$languages{$cur_lang};

  foreach (@Defined_languages)
    {
#   die "Langage $_ is not defined" if ( ! defined ($languages{$_}) ) ;
    $languages{$_}->{'_language'}=$_;
    }

  $language_fr->{'by_chapter'}='Par chapitre';
  $language_us->{'by_chapter'}='By chapter';
  
  $language_fr->{'full_index'}='Index complet';
  $language_us->{'full_index'}='Full index';
  
  $language_fr->{'no_pic_full_index'}='Index complet sans images';
  $language_us->{'no_pic_full_index'}='Full index without pictures';
  
  $language_fr->{'npfi_comment'}='navigation rapide bas dbit';
  $language_us->{'npfi_comment'}='fast browsing for low rate connection';
  
  $language_fr->{'log'}='Journal';
  $language_us->{'log'}='Travel log';
  
  $language_fr->{'log_multiple'}='Journaux';
  $language_us->{'log_multiple'}='Travel logs';
  
  $language_fr->{'back_to_start'}='Retour  l\'entre de l\'album';
  $language_us->{'back_to_start'}='Back to the album main page';
  
  $language_fr->{'next_chapter'}='Chapitre suivant';
  $language_us->{'next_chapter'}='Next chapter';
  
  $language_fr->{'prev_chapter'}='Chapitre prcdent';
  $language_us->{'prev_chapter'}='Previous chapter';
  
  $language_fr->{'next_picture'}='Photo suivante';
  $language_us->{'next_picture'}='Next picture';
  
  $language_fr->{'prev_picture'}='Photo prcdente';
  $language_us->{'prev_picture'}='Previous picture';
  
  $language_fr->{'back_to_index_1'}='Fermez la fentre pour revenir  l\'index';
  $language_us->{'back_to_index_1'}='Close the window to go back to the index';
  
  $language_fr->{'back_to_index_2'}='(ou cliquez ici)';
  $language_us->{'back_to_index_2'}='(or click here)';
  
  $language_fr->{'size_unit'}='kO';
  $language_us->{'size_unit'}='kB';

  $language_fr->{'number_of_pictures'}='Nombre de photos';
  $language_us->{'number_of_pictures'}='Number of pictures';

  return 1 ;
  }


#####################################################################
#####             Write/save album config file                         #####
#####################################################################
# Note: we want the comments and others not te be deleted from teh original files
# We want the order of parameters preserved
# no locking
#
#  we will read the existing config file and write the content in buffer
#  Then we rename buffer -> configfile

#usage: config_file_write($file_alb, \%ConfigTable);
sub config_file_write
  {
  my $nbparam=2; my $funcname='config_file_write';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $configfile=$_[0];
  my $ConfTab=$_[1];

  my %Buffer;
    #This hash will keep track of the parameters already written in the buffer

#  my (BUFFER, $buffer) = tempfile("cgg-XXXXX", SUFFIX=>'.alb') || return set_error("$MEID-1529 - unable to write on buffer file");
  my $buffer=File::Spec->catfile ($STD_TmpDir,"cfgbf.$$.alb");

  open (BUFFER, "> $buffer") ;

  #

  if ( -f $configfile)
    {
    #The file exist, we will edit it
    open (CONFIG_FILE, "< $configfile") || return set_error("$MEID-1529 - unable to open $configfile for edit");
    while ( <CONFIG_FILE> )
      {
      chomp ;
      if ( m/^([^\s=]+)\s*=(.*)$/	) # this will qualify even if value is empty
        {	    
        my($VarName, $VarValue) ;
        $VarName= $1 ;
        $VarValue= $2 ;
        
        if (defined ($VarName) && defined($ConfTab->{$VarName}))
          { # the line is a line of an existing parameter
	  if ( ! defined ($Buffer{$VarName}) )
	    { #this parameter has not already been written
	    $Buffer{$VarName} =1 ;
            print BUFFER "$VarName\t=$ConfTab->{$VarName}\n";
            }
  	  }
	else
	  {
	  #The line is a non existing parameter
          print BUFFER "$_\n" ;
	  }
	}
      else
	{
	#The line is a comment or a not-formated line
        print BUFFER "$_\n" ;
	}
      }
    close(CONFIG_FILE);
    }
  # Here, we finished to write in the buffer the content (edited) of the previous config file, whether existing or not
  
  foreach my $k (sort(keys ( %{ $ConfTab } )) )
    {
    if ( ! defined ($Buffer{$k}) )
      {
      $Buffer{$k}=1;
      print BUFFER "$k\t=$ConfTab->{$k}\n" ;
      }
    }

  #Here: we finished to write the buffer.
  close(BUFFER);

  rename($buffer, $configfile) || return set_error("$MEID-1531 - Unable to write $configfile");
  }

#####################################################################
#####             ReadConfig 1: read File to internal structure #####
#####             and set the unset values to default.
#####################################################################

#For each key not present in the file, the value will be replaced by the default value.
#The hash %forced_to_def will contain the list of forced value to default for information purposes

#usage
# config_file_read_def ($ConfigFile, \%ConfigTable, $default_thumbsize, $default_language, \%forced_to_def)
# return true or undef (error)
sub config_file_read_def
  {
  my $nbparam=5; my $funcname='config_file_read_def';
  ( $#_ +1 == $nbparam ) 
       || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $configfile=$_[0];
  my $ConfTab=$_[1];
  my $default_thumbsize=$_[2];
  my $default_language=$_[3];
  my $forced_to_def=$_[4];

  my %defaults;

  get_config_default_set(\%defaults, $default_thumbsize, $default_language) || return undef;
  

  config_file_read($configfile, $ConfTab) || return undef;

  foreach my $VarName (keys(%defaults))
    { 
    if ( ! defined ($ConfTab->{$VarName}))
      {
      $ConfTab->{$VarName} =  $defaults{$VarName} ; 
      $forced_to_def->{$VarName}=$defaults{$VarName} ; 

      #print STDERR "Warning: var '$VarName' not in config $configfile. Using def='$ConfTab->{$VarName}'.\n" ;
      }
    }
  return 1;
  }

#########################################################################
#####             config_file_read: read File to internal structure #####
#####             the unset values will be undef                    #####
#####  This one will be called by config_file_read_def              #####
#####                                                               #####
#########################################################################

#usage
# config_file_read ($ConfigFile, \%ConfigTable)
# return true or undef (error)

sub config_file_read
  {
  my $nbparam=2; my $funcname='config_file_read';
  ( $#_ +1 == $nbparam ) 
       || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $configfile=$_[0];
  my $ConfTab=$_[1];
  my $default_thumbsize=$_[2];
  my $default_language=$_[3];
  my $forced_to_def=$_[4];

  my %defaults;

  # This will only be used to get the list of keys
  get_config_default_set(\%defaults, 0, 'x') || return undef;
  

  foreach my $k (keys ( %defaults ) )
    {
    $ConfTab->{$k}=undef;
    }

  ( -r $configfile ) || return set_error_4p($MEID, 312, "Unable to read '$configfile'");
  open (CONFIG_FILE, "< $configfile") || return set_error_4p($MEID, 313, "Unable to open '$configfile'");
  while ( <CONFIG_FILE> )
    {
    chomp ;
    if ( m/^([^\s=]+)\s*=(.*)$/ ) # this will qualify even if value is empty
      {     
      my($VarName, $VarValue) ;
      $VarName= $1 ;
      $VarValue= $2 ;

#only read authorized parameters  
      if (defined ($VarName) && defined($defaults{$VarName}))
        {
        if ( defined ($VarValue))
          { $ConfTab->{$VarName} = $VarValue ; }
        else
          { $ConfTab->{$VarName} = '' };
        }
      }
    # print ($VarName, ' = ', $VarValue, "\n");
    }
  close (CONFIG_FILE) ;

  return 1;
  }

#sub config_set_def
#  {
#  my $ConfTab=$_[0];
#
#  my %defaults;
#
#  get_config_default_set(\%defaults, $Options{opt_default_thumbsize}, $Guts{guts_def_language});
#
#  foreach my $VarName (keys(%defaults))
#    { 
#    if ( ! defined ($ConfTab->{$VarName}))
#      {
#      if ( defined $defaults{$VarName} )
#        { $ConfTab->{$VarName} =  $defaults{$VarName} ; }
#      else
#        { $ConfTab->{$VarName} =  '' ; }
#      print STDERR "Warning: var '$VarName' not in config $configfile. Using def='$ConfTab->{$VarName}'.\n" ;
#      }
#    }
#  }


##########################################################################
#####             ReadConfig 2: default config and var interpolation #####
##########################################################################

#Will expand the variables according to spec
#
#Usage config_file_expand ($ConfTab, $ConfigTableExpanded, $fCheckLang ) ;
#
#Will check the language is sepcified (3rd parameter is flag)
# $ConfTab is ref to hash of conftab
# $ConfigTableExpanded is ref to hash of conftab expanded
#
sub config_file_expand
  {
    my $nbparam=3; my $funcname='config_file_expand';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $ConfTab= $_[0]  ;
  my $ConfigTableExpanded= $_[1] ;

#  my %ConfTab=%{ $_[0] } ;
#  my %ConfigTableExpanded=%{ $_[1] } ;

  my $fCheckLang = $_[2] ;

  #Pour chacune de ces variables, on procde  des substitions:
  {
    my ($key, $value);
    while ( ($key, $value) = each %{ $ConfTab } ) 
      {
      if (defined($value))
        {
        #If value contains variable (such as ${TEMP}), then replace ${ENV} by its value
        $value =~ s/(\$\{([^}]+)\})/$ENV{$2}/g ;
        $value =~ s/\$generator/$Guts{guts_product_name}/g ;
        $ConfigTableExpanded->{$key} = $value;
        }
      }
#    while ( ($key, $value) = each %META) 
#      {
#      $value =~ s/\$generator/$Guts{guts_product_name}/g ;
#      $META{$key} = $value;
#      }
  }

  if ( $fCheckLang )
    {
    if ( ! defined ($ConfigTableExpanded->{'Language'}) || $ConfigTableExpanded->{'Language'} eq '' )
      { return set_error ("$MEID-2235 - Language is missing. Supported languages are: ".get_List_defined_languages())   ; }
    if (! defined ($languages{$ConfigTableExpanded->{'Language'}} ) ) 
      { return set_error ("$MEID-2237 - Unsuported or unknown language '".$ConfigTableExpanded->{'Language'}."'. Supported are: ".get_List_defined_languages())   ; }
    }
  return 1;
  }


#####################################################################
#####               Options default values                      #####
#####################################################################
#usage
#  init_default_options(\%Options);
sub init_default_options
  {
  my $nbparam=1; my $funcname='init_default_options';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";

  my $Options=$_[0];
  my $i=0;
                                                            #default values

  $Options->{opt_create_thumbnails}=0;        
  $Options->{opt_rebuild_thumbnails}=0;        
  $Options->{opt_new_thumbnails}=''; 
  $Options->{opt_delete_orphean_thumbn}=0; 
  $Options->{opt_with_ftp_sync}=0; 
  $Options->{opt_crypt_key}=''; 
  $Options->{opt_album_file}=''; 
  $Options->{opt_no_ini_direct_dir}=0; # flag: no ini file: we start from directory
  $Options->{opt_no_ini_start_dir}=''; # directory from where we start
  $Options->{opt_mode_silent}=0; 
  $Options->{opt_create_index_of_album}=0; 
  $Options->{opt_mode_wrap}=0 ;
  $Options->{opt_mode_Warning}=0 ;
  $Options->{opt_loop}=0 ;
  $Options->{opt_default_thumbsize}=$Guts{guts_def_thumb_surf} ;
  }


sub   album_sync_tab
  {
  my $Config_tab=$_[0];
  my $opt_crypt_key=$_[1];
  my $opt_mandatory_cryption=$_[2];

  my $ftp_tmp_sync_file=File::Spec->catfile ($STD_TmpDir,"ftsf.$$.ftp");

  config_file_write($ftp_tmp_sync_file, $Config_tab) || return undef;

  my $r=album_sync_file($ftp_tmp_sync_file, $opt_crypt_key, $opt_mandatory_cryption);
  unlink ($ftp_tmp_sync_file) || return set_error_4p($MEID, 12754,"Unable to delete temporary ftp file $ftp_tmp_sync_file");
  return $r;
  }


sub album_pwd_encrypt
  {
  my $submit=$_[0];
  my $opt_crypt_key=$_[1];

  if ($opt_crypt_key eq '' )
    { return set_error_4p($MEID, 11722, "Encryption key is missing"); }
  if ($submit eq '' )
    { return set_error_4p($MEID, 11720, "String to encrypt/decrypt is empty"); }

  print "External encrypt\n"; 
  my $strCommand= "perl ". File::Spec->catfile ($Guts{guts_script_dir}, $Guts{guts_ftp_script}) ." -P $submit";
  my $strCommand_pwd=" -X <hidden>";
  my $r=qx/$strCommand -X $opt_crypt_key/;  # execute
#  print STDERR "$r\n";
  return set_error_4p($MEID, 11721, "Unknown encryption error. Command was:\n$strCommand$strCommand_pwd") if ( $r eq '');
  chomp($r);
#  print "r=$r\n"; 
  $r =~ s/^(.+) -> (\d*)$/$2/ ;
  return $r;
  }

sub   album_sync_file
  {
  my $Config_file=$_[0];
  my $opt_crypt_key=$_[1];
  my $opt_mandatory_cryption=$_[2];

  if ($opt_crypt_key eq '' && $opt_mandatory_cryption )
    { return set_error_4p($MEID, 11723, "Cannot synchronise, encryption key is mandatory"); }


  print "FTP sync\n"; 
  my $strCommand= "perl ". File::Spec->catfile ($Guts{guts_script_dir}, $Guts{guts_ftp_script}) ." -f $Config_file -uD ";
  my $strCommand_pwd;
  my $r;
  if ($opt_crypt_key eq '')
    { $r=system ("$strCommand"); $strCommand_pwd="";}
  else
    { $r=system ("$strCommand -x $opt_crypt_key"); $strCommand_pwd=" -x <hidden>";}
  return set_error_4p($MEID, 11724, "Cannot synchronise. Command was:\n$strCommand$strCommand_pwd\nPlease check the console message") if ( $r == -1);
  return set_error_4p($MEID, 11725, "Synchronisation error " . ($r/256) . ". Command was:\n$strCommand$strCommand_pwd\nPlease check the console message") if ( ! $r == 0);
  return 1;
  }


#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####             Album creation  (start)                       #####
#####################################################################
#usage
#   album_create_main( \%ConfTab, $opt_rebuild_thumbnails, $opt_delete_orphean_thumbn,
#				$opt_create_thumbnails, $opt_new_thumbnails, $opt_mode_wrap, 
#                               $opt_mode_Warning, $opt_loop, $caller_version);
sub album_create_main
  {
  print_msg ("Initialize\n");
  my $nbparam=9; my $funcname='album_create_main';
  ( $#_ +1 == $nbparam ) 
     || return set_error("$MEID-1530 - Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n" );

  my $ConfTab=$_[0];
  my $opt_rebuild_thumbnails=$_[1];
  my $opt_delete_orphean_thumbn=$_[2];
  my $opt_create_thumbnails=$_[3];
  my $opt_new_thumbnails=$_[4];
  my $opt_mode_wrap=$_[5];
  my $opt_mode_Warning=$_[6];
  my $opt_loop=$_[7];
 
  my $caller_version=$_[8];


  init_bundles($ConfTab->{'Language'}) || return undef; # Definition of language bundles
  print_msg (".");

  my %ConfigTableExpanded ;

  config_file_expand($ConfTab, \%ConfigTableExpanded, 1) || return undef;
  print_msg (".");

  my $TexteAlbum  ;
  my @Titre_principal_HTML;
  my $TitrePrincipal;
  
    {
    my $TitrePrincipal_HTML_coded = $ConfigTableExpanded{'TitrePrincipal'} ;
    @Titre_principal_HTML=ListLocalTreeBuilder ($TitrePrincipal_HTML_coded); 
    my $Titre_principal_tree=HTML::Element->new('div'); $Titre_principal_tree->push_content(@Titre_principal_HTML);
    $TitrePrincipal=$Titre_principal_tree->as_text();
    }
  
  my $MainDir = $ConfigTableExpanded{'MainDir'} ;
  my $Height = $ConfigTableExpanded{'Height'} ;
  my $NbCol = $ConfigTableExpanded{'NbCol'} ;
  my $FontFace = $ConfigTableExpanded{'FontFace'} ;
  my $Tailer = $ConfigTableExpanded{'Tailer'} ;
  my $BODY_bgcolor=$ConfigTableExpanded{'BODY_bgcolor'};
  my $BODY_text=$ConfigTableExpanded{'BODY_text'};
  my $BODY_link=$ConfigTableExpanded{'BODY_link'};
  my $BODY_vlink=$ConfigTableExpanded{'BODY_vlink'};
  my $BODY_alink=$ConfigTableExpanded{'BODY_alink'};
  my $BODY_background=$ConfigTableExpanded{'BODY_background'};
  my $Location=$ConfigTableExpanded{'Location'};
  my $ThumbnailSurface=$ConfigTableExpanded{'ThumbnailSurface'};
  
  my ($FichierDescRef, $FichierDescChapitrs, $FichierDescMain, $FichierDescLog, 
    $REF_DIR,  $TN_DIR,  $ALBUM_DIR_NEW,  $ALBUM_DIR_OLD, $LOG_DIR,
    $ITAG_Path,     $ITNG_Path,     $ATAG_Path,
    $FtpMark_Path, $RDIR_Path, $FtpMark_FileName);
  
  
  $FtpMark_FileName="$ConfigTableExpanded{remote_user}.$ConfigTableExpanded{remote_host}$ConfigTableExpanded{remote_root}";
  $FtpMark_FileName =~ s/\//--/g ;
  
  
  
  #####################################################################
  #####                Fabrication du template HTML               #####
  #####################################################################
  
  #This is to have some part of the document in isolated lines
  $CR="\n";
  $CR_in_comment=HTML::Element->new('~comment', 'text'=>$CR);
  
  my $X_Title= HTML::Element->new('title', 'id'=>'X_Title');
  my $X_Header=HTML::Element->new('head', 'id'=>'X_Header');
  foreach my $MetaItem ('author', 'generator', 'description', 'distribution', 
                       'keywords', 'ownership')
    {
    $X_Header->push_content(HTML::Element->new('meta','name'=>$MetaItem,'content'=>$ConfigTableExpanded{"META_$MetaItem"})) ;
    }
    # meta possibles: Voir www.netstrider.com/tutorials/HTMLRef/commands/meta.html
  $X_Header->push_content($X_Title);
  #Lorsque l'on veut utiliser un template: on le modifie, puis on le clone.
  #After this, the template is already personalized with all options fromp thye config file
  
  #Fabrique le body
  my (%BODY) ;
  $BODY{bgcolor}=$BODY_bgcolor;
  $BODY{text}   =$BODY_text   ;
  $BODY{link}   =$BODY_link   ;
  $BODY{vlink}  =$BODY_vlink  ;
  $BODY{alink}  =$BODY_alink  ;
  
  if (defined ($BODY_background ) && $BODY_background ne '' )
    {$BODY{background}  =$BODY_background  ;}
  else
    {$BODY{background}=undef ;}
  
  
  my $X_Body=HTML::Element->new('body','bgcolor'=>$BODY{'bgcolor'},
   				        'text'   =>$BODY{'text' }  ,
  				        'link'   =>$BODY{'link' }  ,
  				        'vlink'  =>$BODY{'vlink'}  ,
  				        'alink'  =>$BODY{'alink'} , 'id'=>'X_Body');
  if (defined ($BODY{'background'}) )
    {
    $X_Body->attr('background',$BODY{'background'});
    }
  my $X_FileDesc=HTML::Element->new('~comment','text'=>' file descriptor ', 'id'=>'X_FileDesc' );
  my $X_BodyFont=HTML::Element->new('font','face'=>$FontFace, 'id'=>'X_BodyFont');
  $X_Body->push_content($X_FileDesc);
  $X_Body->push_content($X_BodyFont);
  
  my ($X_any);
  my $X_H1=HTML::Element->new('h1', 'id'=>'X_H1');
  $X_any=HTML::Element->new('center');
  $X_any->push_content($X_H1);
  $X_BodyFont->push_content($X_any);
  
  my $X_IntroText=HTML::Element->new('i',, 'id'=>'X_IntroText');
  my $X_IntroImg=HTML::Element->new('td', 'id'=>'X_IntroImg');
  my $X_IntroMenu=HTML::Element->new('td', 'id'=>'X_IntroMenu');
  my $X_IntroMenuListe=HTML::Element->new('ul', 'id'=>'X_IntroMenuListe');
  $X_any=HTML::Element->new('font','size'=>'+1');
  $X_any->push_content($X_IntroMenuListe);
  $X_IntroMenu->push_content($X_any);
  
  $X_any=HTML::Element->new('tr');
  $X_any->push_content($X_IntroImg);
  $X_any->push_content($X_IntroMenu);
  $X_any= ( HTML::Element->new('table')->push_content($X_any) );
  
  my $X_Intro=HTML::Element->new('~comment', 'id'=>'X_Intro','text'=>'Intro');
  $X_Intro->push_content($X_IntroText,['p'],$X_any);
  
  my $X_Frise=HTML::Element->new('hr', 'id'=>'X_Frise');
  my $X_Corpse=HTML::Element->new('p', 'id'=>'X_Corpse');
  
  $X_BodyFont->push_content($X_Intro,$X_Frise,$X_Corpse);

  print_msg (".");
  
  my @HTML_Tailer= ListLocalTreeBuilder($Tailer);
  
  my $X_Address=HTML::Element->new('hr');
  
  
  
  my $X_TailerText=HTML::Element->new('font','face'=>$FontFace, 'id'=>'X_TailerText');
  $X_TailerText->push_content(@HTML_Tailer);
  
  
  $X_Address->push_content($X_TailerText);
  $X_Address= HTML::Element->new('address')->push_content($X_Address);
  $X_Address->attr('id','X_Address');
  
  my $X_Html=HTML::Element->new('html', 'id'=>'X_Html');
  $X_Html->push_content($X_Header, $X_Body, $X_Address);
  
  $X_Html->objectify_text() ;  #On locate toutes les rf  $StampDate et on les remplace par la date ds une lignes isole. On fabrique la ligne isole en utilisant un commentaire qui contient un <CR>, et on insre un autre comment qui contient le litral 'stampdate'.
    #Note: this method only support one occurence of the keyword per node
  foreach my $lt ($X_Html->find_by_tag_name('~text'))
    { 
    if ($lt->attr('text') =~ m/^(.*)\$StampDate(.*)$/ ) 
      { 
      my $left=HTML::Element->new('~text','text'=>$1);
      my $right=HTML::Element->new('~text','text'=>$2);
      $lt->replace_with($left,$CR_in_comment->clone,HTML::Element->new('~comment','text'=>'stampdate'),$StampDate,$CR_in_comment->clone,$right) ;
      } 
    }
  foreach my $lt ($X_Html->find_by_tag_name('~text'))
    { 
    if ($lt->attr('text') =~ m/^(.*)\$Location(.*)$/ ) 
      { 
      my $left=HTML::Element->new('~text','text'=>$1);
      my $right=HTML::Element->new('~text','text'=>$2);
      $lt->replace_with($left,$CR_in_comment->clone,HTML::Element->new('~comment','text'=>'location'),$Location,$CR_in_comment->clone,$right) ;
      } 
    }
  foreach my $lt ($X_Html->find_by_tag_name('~text'))
    { 
    if ($lt->attr('text') =~ m/^(.*)\$STD_Version(.*)$/ ) 
      { 
      my $left=HTML::Element->new('~text','text'=>$1);
      my $right=HTML::Element->new('~text','text'=>$2);
      $lt->replace_with($left,$CR_in_comment->clone,HTML::Element->new('~comment','text'=>'version'),get_guts('guts_lib_version')."/$caller_version",$CR_in_comment->clone,$right) ;
      } 
    }
  $X_Html->deobjectify_text() ;
  print_msg (".");
  
  
  my $RDIR_Html=$X_Html->clone ;
  
  #Depending of the position of the HTML page, the link to the image background, if exist, must be changed
  my $ITAG_Html=$X_Html->clone ;
        $ITAG_Html->look_down('id','X_Body')->attr('background',"../".$BODY{'background'}) if defined($BODY{'background'});
  my $ITNG_Html=$X_Html->clone ;
        $ITNG_Html->look_down('id','X_Body')->attr('background',"../".$BODY{'background'}) if defined($BODY{'background'});
  my $ATAG_Html=$X_Html->clone ;
        $ATAG_Html->look_down('id','X_Body')->attr('background',"../".$BODY{'background'}) if defined($BODY{'background'});
  
  
  
  #####################################################################
  #####         Identification des rpertoires et fichiers        #####
  #####################################################################
  
  print_msg (".");
  
  return set_error("$MEID-0551a - Undefined directory \$MainDir") if ($MainDir eq '' || ! defined($MainDir)) ;
  return set_error("$MEID-0551b - Unable to find directory '$MainDir'") unless -d $MainDir ;
  $REF_DIR=File::Spec->catfile ($MainDir,$Guts{guts_REF_PATH}) ; return set_error("$MEID-0552 - Directory $REF_DIR inaccessible\n") unless -d $REF_DIR ;

  $TN_DIR=File::Spec->catfile ($MainDir,$Guts{guts_TN_PATH}) ;

  if ( ! -d $TN_DIR && ( $opt_rebuild_thumbnails || $opt_create_thumbnails ) )
    {
    if ( $opt_new_thumbnails eq '' || ! defined ($opt_new_thumbnails) )
      {return set_error("$MEID-2215 - Missing thumbnail creation failed: default new chapter is empty\nPlease set a value (example: 'new')") ;}
    else
      { mkdir($TN_DIR) ; }
    }

  if ( ! -d $TN_DIR && ( $opt_rebuild_thumbnails || $opt_create_thumbnails ) )
    { mkdir($TN_DIR) ; }
  return set_error("$MEID-0553 - Directory $TN_DIR inaccessible\n") unless -d $TN_DIR ;
  
  $ALBUM_DIR_NEW=File::Spec->catfile ($MainDir,$Guts{guts_ALB_PATH_N});
  $ALBUM_DIR_OLD=File::Spec->catfile ($MainDir,$Guts{guts_ALB_PATH_O});
  $LOG_DIR=File::Spec->catfile ($MainDir,$Guts{guts_LOG_PATH});
  
  $FichierDescRef     =File::Spec->catfile($REF_DIR,"descript.ion") ; print_msg( "No file $FichierDescRef\n",1,*STDERR) unless -r $FichierDescRef ;
  $FichierDescChapitrs=File::Spec->catfile($TN_DIR, "descript.ion") ; print_msg("No file $FichierDescChapitrs\n",1,*STDERR) unless -r $FichierDescChapitrs ;
  if ( -d $LOG_DIR) { $FichierDescLog=File::Spec->catfile($LOG_DIR, "descript.ion") ; print_msg("No file $FichierDescLog\n",1,*STDERR) unless -r $FichierDescLog ; }
  $FichierDescMain=File::Spec->catfile($MainDir, "descript.ion") ; print_msg("No file $FichierDescMain\n",1,*STDERR) unless -r $FichierDescMain ;
  
  $ATAG_Path=File::Spec->catfile ($ALBUM_DIR_NEW,$Guts{guts_ATAG_FN}) ;
  $ITAG_Path=File::Spec->catfile ($ALBUM_DIR_NEW,$Guts{guts_ITAG_FN}) ;
  $ITNG_Path=File::Spec->catfile ($ALBUM_DIR_NEW,$Guts{guts_ITNG_FN}) ;
  $FtpMark_Path=File::Spec->catfile ($MainDir,$FtpMark_FileName) ;
  
  $RDIR_Path=File::Spec->catfile ($MainDir,$Guts{guts_RDIR_FN}) ;
  
  print_msg (".\n");
  if ( ! -d $ALBUM_DIR_NEW ) 
    { mkdir ($ALBUM_DIR_NEW,777) || return set_error("$MEID-2100530: Impossible de crer rpertoire $ALBUM_DIR_NEW\n") ; }
  else
    { 
    print_msg ("Deleting previous garbage\n");
    deltree ($ALBUM_DIR_NEW) || print_msg( "Warning 495: unable to deltree directory $ALBUM_DIR_NEW.\n",1,*STDERR)  ;
    mkdir ($ALBUM_DIR_NEW,777) || print STDERR "Warning 496: unable to create directory $ALBUM_DIR_NEW: $!\n"  ;
    return set_error("$MEID-0554 - Missing directory $ALBUM_DIR_NEW.\n") unless -d $ALBUM_DIR_NEW ;
    }
  
  
  
  
  #####################################################################
  #####             Chargement de la liste des chapitres            #####
  #####################################################################
  
  print_msg ("Reading directories and descriptions.\n");

  #Les structures:
  my (%DirnameDesChapitres, @ListeDesChapitres, $NbDeChapitres) ;
  
  # %DirnameDesChapitres = hachoir index par numro de 1  $NbDeChapitres qui contient le leafname lowercase de chaque chapitre
  # @ListeDesChapitres = liste des leafname tris et lower-case des chapitres (pris dans le rpertoire des thumbnails)
  
  
  {
    #rcup de la liste des rpertoires thumbnails, qui est la liste des chapitres
    my (@DirDesChapitres) ;
    opendir (TN_DIR, $TN_DIR) || return set_error("$MEID-055504 - Directory $TN_DIR inaccessible" );
    @DirDesChapitres = readdir(TN_DIR) ;
    close (TN_DIR) ;
    
    foreach my $ii (0..(@DirDesChapitres-1))
      {
      $DirDesChapitres[$ii] = lc ($DirDesChapitres[$ii]) ;
      }
    @DirDesChapitres = sort @DirDesChapitres ;
    
    #On passe en revue les rpertoires un par un, on les numrote dans le hash.
    #On a besoin de faire ceci pour pouvoir construire le tag 'chapitre suivant'
    my ($ChapitrNumber) ;
    $ChapitrNumber=0;
    %DirnameDesChapitres = () ;
    foreach my $Chapitr (@DirDesChapitres)
      {
      if ($Chapitr ne '' && $Chapitr ne '.' && $Chapitr ne '..' && -d File::Spec->catfile($TN_DIR,$Chapitr) && -r File::Spec->catfile($TN_DIR,$Chapitr) )
        {
        @ListeDesChapitres = (@ListeDesChapitres, $Chapitr);
        $ChapitrNumber++ ;
        $DirnameDesChapitres{$ChapitrNumber} = $Chapitr ;
        }
      }
    $NbDeChapitres=$ChapitrNumber ;
  }
  print_msg (". ");
  
       
  #####################################################################
  #####                 Chargement des descriptions               #####
  #####################################################################
  
  
  %DescriptionACD = () ;
  
  # %DescriptionACD = description ACDSEE en texte (ascii pour l'instant) pour aussi bien desc. des images de ref, et des chapitres. Le hachoir est index par filename lowercase: soit leafname, soit pathname
  #           Dans le cas des fichiers sous les rpertoires de thumbnails: en pathanme
  #           Dans les autres cas: en leafname
  
  #Les description des images ref et celle de chapitres 
  #On charge aussi celle du header.
     # $FichierDescRef      : contains the comments of the pictures
     # $FichierDescChapitrs : contains the name of the chapters
     # $FichierDescMain     : contains the comments on the main header
  
  #This will store all descriptions, whatever the type of file (wav, jpg...)
     
  foreach my $FichDesc ($FichierDescRef, $FichierDescChapitrs, $FichierDescMain)
    {
    $DescriptionACD{'logs'}=undef;
    insert_in_descriptionACD_hachoir ($FichDesc,'filemode')  ;
    print_msg (".");
    }
  print_msg (" ");

  #bug possible here. If there is a previous 'insert_in_descriptionACD_hachoir' that contain a comment for 'logs', and maindir does not contain one, then the previous one will be used.
  #this cannot happen here because we do $DescriptionACD{'logs'}=undef;
  #clean solution: solution: create a third mode in 'insert_in_descriptionACD_hachoir' to append a prefix that cannot be misinterpreted as a directory
  #    $forced_journal_key=$DescriptionACD{'logs'} if (defined ($DescriptionACD{'logs'})) ;

    
  #For each chapter, we get the description file for the files under the thumbnail directories
    # This will contain the descritpion of the header of each chapter
    
  foreach my $Chapt (@ListeDesChapitres)
    {
    insert_in_descriptionACD_hachoir (File::Spec->catfile(File::Spec->catfile($TN_DIR,$Chapt),'descript.ion'),'parentmode')  ;
    print_msg (".");
    }
  print_msg ("\n");
  
    
  #######################################################################
  #####    Load sizes of images and thumbnails: Initialize structures ###
  #######################################################################
      
  %WidthesDesBigImages = () ; %HeightsDesBigImages = () ; %SizesDesBigImages = () ;
  %WidthesDesThumbNails = () ; %HeightsDesThumbNails = () ; %SizesDesThumbNails = () ;
  %PremChapitrDeCetteImage = () ;
  
  #Structures:
  #  DesBigImages  = images from ref
  #  DesThumbNails = images from thumbnail dir + main header
  #    Indexed on leafname of pictures except for headers of chapters
  
  print_msg ("Loading image sizes.\n");
  
  my $HeadPhotIndBasename=''; 
    {
    my $HPI_Path = '' ;
    my $Ext ;
    #Locate main header
    foreach $Ext ( '.gif', '.jpeg', '.jpg')
      { if ( -f File::Spec->catfile($MainDir,"header$Ext") ) 
        { $HeadPhotIndBasename = "header$Ext"; $HPI_Path = File::Spec->catfile($MainDir,$HeadPhotIndBasename) ; } }
    
    if ( $HPI_Path )
      {
      my $i =Image::Magick->new;
      $i->Read($HPI_Path);
      ($HeightsDesThumbNails{"$HeadPhotIndBasename"}, $WidthesDesThumbNails{"$HeadPhotIndBasename"}, $SizesDesThumbNails{"$HeadPhotIndBasename"})=$i->Get('height','width', 'filesize');
      }
    }
  
  
  ######################################################################
  #####    Load sizes of images and thumbnails: main loop by chapter ###
  ######################################################################
  foreach my $ChapitrLabel (@ListeDesChapitres)
    {
    print_msg (".");
    my $SRC_CHAPITR_DIR=File::Spec->catfile($TN_DIR,$ChapitrLabel) ;
    if ( ! -d $SRC_CHAPITR_DIR ) 
      { return set_error("$MEID-055530 - Directory $SRC_CHAPITR_DIR inaccessible.\n") ; }
    opendir (SRC_CHAPITR_DIR, $SRC_CHAPITR_DIR) || return set_error("$MEID-055600 - Directory $SRC_CHAPITR_DIR inaccessible.\n") ;
  
    my @FileListDuChapitre = readdir(SRC_CHAPITR_DIR) ;
    foreach my $ii (0..(@FileListDuChapitre-1))
      { #Convertir en lowercase
      $FileListDuChapitre[$ii] = lc ($FileListDuChapitre[$ii]) ;
      # test blank
      if ( $FileListDuChapitre[$ii] =~ m/ / )
        { return set_error("$MEID-0551 - blank detected in file  '".$FileListDuChapitre[$ii]."'. Not supported"); }
      }
    
    #on Rcupre les tailles des thumbnails et des images ref dans deux hachoirs: NomDesRef{index par nom de TN} et NomDesTN{index par nom de ref}
      {
      my ($ImageRef);
  
      #Dans le cas o il faille les refaire, c'est ici: pas de lecture des tailles des thumbnails,  la place: les refaire...
  
  ###########################################################################
  ##### Load sizes of images and thumbnails: Sub loop for each thumbnail ###
  ###########################################################################
  
      foreach my $TNFileName (@FileListDuChapitre)
        {             # Le /i pour case insensitive
        
        
        ###############  Case where it's a header of chapter
        if ( $TNFileName =~ /header\.jpg$/i || $TNFileName =~ /header\.jpeg$/i || $TNFileName =~ /header\.gif$/i)
          #Ceci est un header de A1AG
          {
  	my $i =Image::Magick->new;
          $i->Read(File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName));
          ($HeightsDesThumbNails{"$ChapitrLabel/$TNFileName"}, $WidthesDesThumbNails{"$ChapitrLabel/$TNFileName"}, $SizesDesThumbNails{"$ChapitrLabel/$TNFileName"})=$i->Get('height','width', 'filesize');
          }
  
        ###############  Case where it's a regular thumbnail
        elsif ( ($TNFileName =~ /tn_.*\.jpg$/i || $TNFileName =~ /tn_.*\.jpeg$/i || $TNFileName =~ /tn_.*\.gif$/i)
             && ( -f File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName) && 
                  -r File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName) ) )
          {
          $ImageRef = $TNFileName ; $ImageRef =~ s/^tn_//i ;
  
          #Si l'image source est gif, le TN risque d'tre en jpg malgr tout.
  	  {
  	  my $ImageRefGif = $ImageRef ;
  	  $ImageRefGif =~ s/\.jpe?g$/.gif/i ;
  
            #We test if the ref image exist as usual file (same extension as thumbnail)
  	  if ( -f File::Spec->catfile($REF_DIR,$ImageRef))
  	    { 
  	    $NomDesRef{$TNFileName} = $ImageRef ; 
  	    $NomDesTN{$ImageRef} = $TNFileName ; 
  	    }
            # and if not: we test if the ref image exist as GIF file
  	  elsif ( (! -f File::Spec->catfile($REF_DIR,$ImageRef)) && (-f File::Spec->catfile($REF_DIR,$ImageRefGif)) )
  	    { $NomDesRef{$TNFileName} = $ImageRefGif ;
  	      $NomDesTN{$ImageRefGif} = $TNFileName ; 
  	      $ImageRef = $ImageRefGif ; }
  	  }
    
          #Update table of known sizes (indexed by leafname of $TNFileName)
          if ( -f File::Spec->catfile($REF_DIR,$ImageRef) && -r File::Spec->catfile($REF_DIR,$ImageRef) )
            {
            if ($opt_rebuild_thumbnails ) 
  ###########################################################################
  ##### Load sizes of images and thumbnails: Rebuild all                  ###
  ###########################################################################
              {
              #We know the thumbnail exist. We shall delete it and rebuild it
              print_msg ("Rebuilding thumbnail $ChapitrLabel/$TNFileName");
              #temporary to ntnpath
              my $ntnpath=File::Spec->catfile($SRC_CHAPITR_DIR,"$TNFileName.tmp");
              unlink ($ntnpath) if ( -f $ntnpath);
              my ($h, $w, $S, $h2, $w2, $S2) = create_thumbnail( 
                            File::Spec->catfile ($REF_DIR,$ImageRef),
                            $ntnpath,
                            $ThumbnailSurface ) ;
              if ( defined ($h2) )
                {
                print_msg (" ($h x $w -> $h2 x $w2).\n"); 
                unlink(File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName));
                move ($ntnpath,File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName));
                $WidthesDesThumbNails{$TNFileName} = $w2 ;
                $HeightsDesThumbNails{$TNFileName} = $h2 ;
                $SizesDesThumbNails{$TNFileName} = $S2 ;        
                $PremChapitrDeCetteImage{$TNFileName} = $ChapitrLabel unless defined ($PremChapitrDeCetteImage{$TNFileName} );        
                }
              else
                {
       #create thumbnail failed
                print_msg (" Failed.\n"); 
                unlink ($ntnpath) if ( -f $ntnpath);
                
                #Use stat of current thumbnail
                my ($width, $height, $size) =  get_image_stats (File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName)) ;
                if (defined($width) && defined($height) && defined($size)) 
                  {
                  $WidthesDesThumbNails{$TNFileName} = $width ;
                  $HeightsDesThumbNails{$TNFileName} = $height ;
                  $SizesDesThumbNails{$TNFileName} = $size ;        
                  $PremChapitrDeCetteImage{$TNFileName} = $ChapitrLabel unless defined ($PremChapitrDeCetteImage{$TNFileName}) ;        
                  }
                else #stat of thumbnail unavailable
                  {
                  print_msg ("Error: ".get_error(0),1,*STDERR) 
                  }
                }
              }
            else 
  	    {
  ###########################################################################
  ##### Load sizes of images and thumbnails: Memorize                     ###
  ###########################################################################
  	    if ( ! defined $SizesDesThumbNails{$TNFileName} )
  	      {
                my ($width, $height, $size) =  get_image_stats (File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName)) ;

                if (defined($width) && defined($height) && defined($size)) 
                  {
                  $WidthesDesThumbNails{$TNFileName} = $width ;
                  $HeightsDesThumbNails{$TNFileName} = $height ;
                  $SizesDesThumbNails{$TNFileName} = $size ;        
                  $PremChapitrDeCetteImage{$TNFileName} = $ChapitrLabel ;        
                  }
                else #stat of thumbnail unavailable
                  {
                  print_msg ("Error: ".get_error(0),1,*STDERR) 
                  }

  	      }
              }
            if ( ! defined ($SizesDesBigImages{$ImageRef}) )
              {
  	    if ( $ImageRef =~ m/^header\.[^.]+$/ )
  	      { print "Image named header.* are forbiden... Ignored.\n"; }
  	    else
  	      {
                my ($width, $height, $size) =  get_image_stats (File::Spec->catfile($REF_DIR,$ImageRef)) ;
                if (defined($width) && defined($height) && defined($size)) 
                  {
                $WidthesDesBigImages{$ImageRef}=$width ;
                $HeightsDesBigImages{$ImageRef}=$height ;
                $SizesDesBigImages{$ImageRef}=$size ;
                  }
                else #stat of thumbnail unavailable
                  {
                  print_msg ("Error: ".get_error(0),1,*STDERR) 
                  }

  	      }
              } 
  
            }
          else
            { 
            if ( $opt_delete_orphean_thumbn) 
              {
              print_msg ("Deleting thumbnail $ChapitrLabel/$TNFileName.\n",1,*STDOUT); 
              unlink(File::Spec->catfile($SRC_CHAPITR_DIR,$TNFileName));
              delete($WidthesDesThumbNails{$TNFileName});
              delete($HeightsDesThumbNails{$TNFileName});
              delete($SizesDesThumbNails{$TNFileName});
              delete($PremChapitrDeCetteImage{$TNFileName});
              
              }
            else
              {
              print_msg ("Warning: missing ref image of $ChapitrLabel/$TNFileName.\n",1,*STDOUT); 
              }
            }
          }
        } # fin du foreach my $TNFileName (@FileListDuChapitre)
      }  
    }
  print_msg ("\n");
  
  #Maintenant, on est en mesure de chercher les ref qui n'ont pas de corresponding thumbnails.
  
  
  ############################################################################
  ##### Load sizes of images and thumbnails: Find sterile ref, loop by ref ###
  ############################################################################
  opendir (REF_DIR, $REF_DIR) || return set_error("$MEID-055639 - unable to open $REF_DIR.\n" );
  my @FileListDeRef = readdir(REF_DIR) ;
  closedir(REF_DIR);
  foreach my $ref_file_name (@FileListDeRef)
    {
    $ref_file_name=lc($ref_file_name);
    if ( is_image($ref_file_name) )
      {
      if ( ! defined $NomDesTN{$ref_file_name} )
        {
#        print STDERR "";
        if ( $opt_create_thumbnails )
          {	   
  ############################################################################
  ##### Load sizes of images and thumbnails: create new thumbnails         ###
  ############################################################################

          if ( $opt_new_thumbnails eq '' || ! defined ($opt_new_thumbnails) )
           {return set_error("$MEID-2216 - Missing thumbnail creation failed: default new chapter is empty\nPlease set a value (example: 'new')") ;}
          else
           {mkdir($TN_DIR) ;}

        print "Creating thumbnail $opt_new_thumbnails/tn_$ref_file_name";       
  	my $ntndir=File::Spec->catfile($TN_DIR,$opt_new_thumbnails);
  	my $ntnpath=File::Spec->catfile ($ntndir,"tn_$ref_file_name");
  	if ( ! -d $ntndir)
  	  {
          mkdir ($ntndir, 777)  || return set_error("$MEID-055749 - unable to create $ntndir");
  	  $NbDeChapitres++ ;
  	  $DirnameDesChapitres{$NbDeChapitres}=$opt_new_thumbnails;
  	  push @ListeDesChapitres, $opt_new_thumbnails ;
  
  	  }
          my ($h, $w, $S, $h2, $w2, $S2) = create_thumbnail( 
  	                  File::Spec->catfile ($REF_DIR,$ref_file_name),
  	                  $ntnpath,
  			  $ThumbnailSurface ) ;
          if ( defined ($h2) )
  	  {
  	print " ($h x $w -> $h2 x $w2).\n";	
  
          $NomDesTN{$ref_file_name}="tn_$ref_file_name";
  	$NomDesRef{"tn_$ref_file_name"} = $ref_file_name ; 
          $WidthesDesThumbNails{"tn_$ref_file_name"} = $w2 ;
          $HeightsDesThumbNails{"tn_$ref_file_name"} = $h2 ;
          $SizesDesThumbNails{"tn_$ref_file_name"} = $S2 ;        
  	$PremChapitrDeCetteImage{"tn_$ref_file_name"} = $opt_new_thumbnails ;        
  
          $WidthesDesBigImages{$ref_file_name}=$w;
  	$HeightsDesBigImages{$ref_file_name}=$h;
  	$SizesDesBigImages{$ref_file_name}="$S";
            }
  	else
  	  { print " Failed.\n"; }
  	}
        else
          {
  	print "No thumbnail for $ref_file_name.\n";
  	}
        }
      }
    }
  
  
  
  print_msg ("HTML generation.\n");
  
  #####################################################################
  #####                   Dtection des logs                      #####
  #####################################################################
  my (@ListeDesLogs);
  @ListeDesLogs = () ;
  if ( -d $LOG_DIR)
    {
    my (@DirDesLogs) ;
    opendir (LOG_DIR, $LOG_DIR) || return set_error("$MEID-055814 - rpertoire $LOG_DIR inaccessible") ;
    @DirDesLogs = readdir(LOG_DIR) ;
    close (LOG_DIR) ;

    my $log_desc=File::Spec->catfile($LOG_DIR,'descript.ion');
    insert_in_descriptionACD_hachoir ($log_desc,'parentmode') if (-f  $log_desc);

    foreach my $ii (0..(@DirDesLogs-1))
      {
      $DirDesLogs[$ii] = lc ($DirDesLogs[$ii]) ;
      }
    @DirDesLogs = sort @DirDesLogs ;
    foreach my $Log (@DirDesLogs)
      {
      if ($Log ne '' && $Log ne '.' && $Log ne '..' && -f File::Spec->catfile($LOG_DIR,$Log) && -f File::Spec->catfile($LOG_DIR,$Log) 
          && $Log =~ /\.html?$/i )
        {
        @ListeDesLogs = (@ListeDesLogs, $Log);
        }
      }
    
    }
  
  #####################################################################
  #####               Fabrication du IntroMenuListe               #####
  #####################################################################
  
  #Pour le IntroMenuListe: fabrique le menu  partir de la liste des chapitrs
  
  my $ITAG_ChapitrList=HTML::Element->new('ul');
  my $ATAG_ChapitrList=HTML::Element->new('ul');
  my $ITNG_ChapitrList=HTML::Element->new('ul');
  
  
  foreach my $NoChapitr (1..$NbDeChapitres)
    {
    my (@CommentaireDir);
    if (defined $DescriptionACD{$DirnameDesChapitres{$NoChapitr}} )
      { @CommentaireDir = ListLocalTreeBuilder ( $DescriptionACD{$DirnameDesChapitres{$NoChapitr}} ); }
    else
      {@CommentaireDir =  ($DirnameDesChapitres{$NoChapitr}) ;}
      
    my $LiElement = HTML::Element->new('li')->push_content(
          HTML::Element->new('~comment','text'=>"gr#$NoChapitr"),
          HTML::Element->new('a','href'=>"\#$DirnameDesChapitres{$NoChapitr}")->push_content(@CommentaireDir) 
  	                                                ) ;
      
    $ITAG_ChapitrList->push_content($LiElement);
    $ITNG_ChapitrList->push_content($LiElement->clone);
  
    $LiElement = HTML::Element->new('li')->push_content(
        HTML::Element->new('~comment','text'=>"gr#$NoChapitr"),
        HTML::Element->new('a','href'=>"$DirnameDesChapitres{$NoChapitr}/$Guts{guts_I1AG_FN}")->push_content(@CommentaireDir) 
                                                        ) ;
  
    $ATAG_ChapitrList->push_content($LiElement);
       
    }
  
  $ATAG_ChapitrList = HTML::Element->new('li')->push_content($language_bundle->{'by_chapter'}, $ATAG_ChapitrList);
  
  my $ATAG_UpChapitrList = HTML::Element->new('ul');
  $ATAG_UpChapitrList -> push_content($ATAG_ChapitrList);
  $ATAG_UpChapitrList -> push_content(['li'], ( HTML::Element->new('a','href'=>transfolink($Guts{guts_ITAG_FN}))->push_content($language_bundle->{'full_index'}                                          )) );
  $ATAG_UpChapitrList -> push_content(['li'], ( HTML::Element->new('a','href'=>transfolink($Guts{guts_ITNG_FN})    )->push_content($language_bundle->{'no_pic_full_index'}.' ('.$language_bundle->{'npfi_comment'}.')')) );
  
    {
    my $journalkey; 
    if (defined ($DescriptionACD{'logs'})) 
      { $journalkey = $DescriptionACD{'logs'} ; }
    elsif ( $#ListeDesLogs+1 == 1 ) 
      { $journalkey = $language_bundle->{'log'}; }
    elsif ( $#ListeDesLogs+1 > 1 )
      {$journalkey = $language_bundle->{'log_multiple'}; }

      
    if ( $#ListeDesLogs >= 0 ) 
      {
      my $ul=HTML::Element->new('ul');
      $ATAG_UpChapitrList -> push_content(['li'], $journalkey, $ul );
      foreach my $j (@ListeDesLogs)
        {
        my $dj=$j; my $pj=File::Spec->catfile(basename($LOG_DIR),$j);
        $dj=$DescriptionACD{$pj} if (defined($DescriptionACD{$pj})) ;
        $ul->push_content(['li',HTML::Element->new('a','href'=>transfolink("../$Guts{guts_LOG_PATH}/$j"))->push_content($dj)]);
        }
      }
    }
  
       
  #####################################################################
  #####                   Fabrication du Corpse                   #####
  #####################################################################
  #Build a stamp. A arbitrary string which length is random.
  
  my $Stamp="3.1415926535 8979323846 2643383279 5028841971 6939937510 5820974944 5923078164 0628620899 8628034825" ;
  $Stamp=substr($Stamp,0,int(rand 99)+1);
  
  my $RDIR_Corpse=$RDIR_Html->look_down('id','X_Corpse');
  my $ITAG_Corpse=$ITAG_Html->look_down('id','X_Corpse');
  my $ITNG_Corpse=$ITNG_Html->look_down('id','X_Corpse');
  my $ATAG_Corpse=$ATAG_Html->look_down('id','X_Corpse');
  
  my $ITNG_ListContent=HTML::Element->new('ul');
  $ITNG_Corpse->push_content($ITNG_ListContent);
  
  my ($ChapitrPrec, $ChapitrSuiv, $GrandCounter, $NoDeChapitre) = ("", "", 0, 0);
  
  #Grande boucle: pour chaque chapitre d'abord, puis en sous-boucle pour chaque fichier TN trouv dans le rpertoire du chapitre
    
#my $dbg_x=0;

  foreach my $ChapitrLabel (@ListeDesChapitres)
    {
#$dbg_x++;

    my $SRC_CHAPITR_DIR=File::Spec->catfile($TN_DIR,$ChapitrLabel) ;
    opendir (SRC_CHAPITR_DIR, $SRC_CHAPITR_DIR) || return set_error("$MEID-055835 - rpertoire $SRC_CHAPITR_DIR inaccessible.\n") ;
    my @FileListDuChapitre = readdir(SRC_CHAPITR_DIR) ;
    closedir(SRC_CHAPITR_DIR);

    foreach my $ii (0 .. $#FileListDuChapitre)
      { #Convertir en lowercase
      $FileListDuChapitre[$ii] = lc ($FileListDuChapitre[$ii]) ;
      }
    my $I1AG_Path=File::Spec->catfile($ALBUM_DIR_NEW,File::Spec->catfile($ChapitrLabel,$Guts{guts_I1AG_FN})) ;
    if ( ! -d File::Spec->catfile($ALBUM_DIR_NEW,$ChapitrLabel) ) 
      { mkdir File::Spec->catfile($ALBUM_DIR_NEW,$ChapitrLabel) || return set_error("$MEID-0551 - impossible de crer $ALBUM_DIR_NEW\\$ChapitrLabel.\n" ); }
  
    #On donne des numros aux thumbnails du chapitre
    $NoDeChapitre++ ;
    my (@ImageListDuChapitre, %NoDesImages) ;
    
    @FileListDuChapitre = sort @FileListDuChapitre ;
    %NoDesImages = () ;

  #the list of files will be transfered from FileListDuChapitre to ImageListDuChapitre
  #the file will be inserted if $SizesDesThumbNails{file} is defined which has been set in earlier stage (load image sizes)
    @ImageListDuChapitre = () ;
      {
      print_msg (".");
      my ($ImageRef);
      my $SmallCounter = 0 ;
      foreach my $TNFileName (@FileListDuChapitre)
        {             # Le /i pour case insensitive
        if ( defined $SizesDesThumbNails{$TNFileName} || $TNFileName =~ /^header\./i ) 
        #Ceci sert de repre pour savoir que les fichiers sont prsents
          {
          @ImageListDuChapitre = (@ImageListDuChapitre, $TNFileName);
          $ImageRef = $NomDesRef{$TNFileName} ;
          if ( $TNFileName =~ m/^tn_/i )
            { 
            $SmallCounter++;
  	    $NoDesImages{$SmallCounter} = $ImageRef ; 
            }

          }
        }
      }  
  
    #Boucle pour chaque chapitre.
    #Nous crons pour chaque chapitre un arbre. Sauf pour ATAG qui n'a pas de contenu par chapitre.
    my ($ITAG_ChapitrContent, $ITAG_ChapitrContent_sub, $I1AG_Intro_content, $I1AG_Intro_img, $I1AG_ChapitrContent, $I1AG_ChapitrContent_sub, $ITNG_ChapitrContent);
    #Pour $ITAG_ChapitrContent et I1AG_ChapitrContent, c'est un arbre TABLE avec des TR qui contiennent 4 TD
    #Pour $ITNG_ChapitrContent, c'est un arbre UL avec des LI et des <a name> sur les chapitres
    
    $ITAG_ChapitrContent=HTML::Element->new('table', 'border'=>1);
    $ITAG_ChapitrContent_sub=HTML::Element->new('tr');
    $I1AG_ChapitrContent=HTML::Element->new('table','border'=>1);
    $I1AG_ChapitrContent_sub=HTML::Element->new('tr');
    $ITNG_ChapitrContent=HTML::Element->new('ul');
  
    #Chaque chapitre peut contenir une intro si un fichier header.jpg existe dans son rpertoire de thumbnails.
    $I1AG_Intro_content=HTML::Element->new('div');
    $I1AG_Intro_img=HTML::Element->new('div');
    
    # $I1AG_Intro_content: celui-ci est initialis 
  
    #Maintenant: nous bouclons sur les fichiers par chapitres de N col
    
    my ($ColCounter) = (0) ;
    my $SmallCounter=0;
    my $PhotoPrec = "" ;
#    print "dbg $SRC_CHAPITR_DIR ($dbg_x)\n";
    IMAGE_LIST_DU_CHAPITRE: foreach my $Fichier (@ImageListDuChapitre)
      {
      # print STDERR "file $Fichier\n";
      ### Specific case of the header
#      print "$Fichier " if ($dbg_x == 6);
      if ($Fichier =~ m/header\./i )
        { 
#        print "dbg-header located in '$SRC_CHAPITR_DIR'\n";
        my $header_img=HTML::Element->new(
            'img', 
  	  
  #        ($HeightsDesThumbNails{"$SRC_CHAPITR_DIR/$TNFileName"}, $WidthesDesThumbNails{"$SRC_CHAPITR_DIR/$TNFileName"}, $SizesDesThumbNails{"$SRC_CHAPITR_DIR/$TNFileName"})=$i->Get('height','width', 'filesize');
  #$DescriptionACD{File::Spec->catfile ($basename_of_dir,$ImageRef)}	  
  	  
            'src'=>transfolink("../../$Guts{guts_TN_PATH}/$ChapitrLabel/$Fichier"),
            'width'=>$WidthesDesThumbNails{"$ChapitrLabel/$Fichier"},
            'height'=>$HeightsDesThumbNails{"$ChapitrLabel/$Fichier"});
        $I1AG_Intro_img->push_content($header_img);
        
        if ( defined ($DescriptionACD{File::Spec->catfile ($ChapitrLabel,$Fichier)} ) )
          { $I1AG_Intro_content->push_content(ListLocalTreeBuilder($DescriptionACD{File::Spec->catfile ($ChapitrLabel,$Fichier)})); }
        
        next IMAGE_LIST_DU_CHAPITRE ;
        }
  
      next IMAGE_LIST_DU_CHAPITRE if ( ! defined $NomDesRef{$Fichier} ) ;
  
      my $ImageRef = $NomDesRef{$Fichier} ;
      
      $GrandCounter ++;
      $SmallCounter ++ ;
      $ColCounter ++ ;
  
  
  ###Detect and identifie sound file
      my $SoundFile=''; my @descSoundFile = (); my $SizeSoundFile;
  
      my $ImageRefNoExt = $ImageRef; $ImageRefNoExt =~ s/\..+$// ;
      foreach my $SoundFileExt ( '.wav', '.mp3', '.avi')
        { 
        if ( -f File::Spec->catfile($REF_DIR,"$ImageRefNoExt$SoundFileExt") ) 
          { $SoundFile = $ImageRefNoExt.$SoundFileExt ;}
        last ;  
        }
      
      if ( $SoundFile ne '' )
        {
        if (defined $DescriptionACD{$SoundFile})
          { @descSoundFile = (ListLocalTreeBuilder ("$DescriptionACD{$SoundFile} "), ' '); }
        else
          { @descSoundFile = ("") ; }
  
        my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
            $atime,$mtime,$ctime,$blksize,$blocks)
            = stat(File::Spec->catfile($REF_DIR,$SoundFile));
        $SizeSoundFile=$size;
        }      
  
      #Pour un thumbail donn
      #Nous construisons l'arbre qui correspond au descriptif HTML de ce thumbnail seul au sein de son chapitre
  
      my ($ITAG_TN, $I1AG_TN, $ITNG_TN, $Z1AG_TN);
      { #Standard presentation for index: the image with comment in a <TD>
        my ($comment, $img, $a1, $a2, @descri, $x);
        $ITAG_TN=HTML::Element->new('td', 'align'=>'center');
        $comment=HTML::Element->new('~comment','text'=>"gr#$NoDeChapitre, ph#$SmallCounter");
  #      $img=HTML::Element->new(
  #          'img', 
  #          'src'=>transfolink("../$Guts{guts_TN_PATH}/$ChapitrLabel/$Fichier"),
  #          'width'=>$WidthesDesThumbNails{$Fichier},
  #          'height'=>$HeightsDesThumbNails{$Fichier},
  #	  'id'=>"I-$Fichier");
  #      $a1=HTML::Element->new(
  #          'a', 
  #          'target'=>"_x_$GrandCounter",
  #          'href'=>transfolink("$ChapitrLabel/$ImageRef.html"),
  #	  'id'=>"A-$Fichier");
        $a2=HTML::Element->new(
            'a', 
            'target'=>'_blank', # "_x_$GrandCounter",
            'href'=>transfolink("$ChapitrLabel/$ImageRef.html"),
  	  'id'=>"A2-$Fichier");
  #      $a1->push_content($img);
  
        my @aa1=ListLocalTreeBuilder(
           "<a href=".transfolink("$ChapitrLabel/$ImageRef.html").
           " id=A-$Fichier target=_blank><img src=".transfolink("../$Guts{guts_TN_PATH}/$ChapitrLabel/$Fichier").   # formerly: target=_x_$Fichier
           " height=$HeightsDesThumbNails{$Fichier} width=$WidthesDesThumbNails{$Fichier} id=I-$Fichier ></a>");  
  
  
        if (defined $DescriptionACD{$ImageRef})
          { @descri = ListLocalTreeBuilder ($DescriptionACD{$ImageRef}); }
        else
          { @descri = ("") ; }
        my $str_x=int($SizesDesBigImages{$ImageRef}/1024);
  
        my @SoundFileBunchHtml=();
        if ( $SoundFile ne '' )
          {
          my $str_y= int ( $SizeSoundFile / 1024) ;
          @SoundFileBunchHtml=( ListLocalTreeBuilder("
                                  <br>Sound file: "), 
                                @descSoundFile, 
                                ListLocalTreeBuilder(
                                 "<embed autostart=false hidden=false loop=false 
          src=../../$Guts{guts_REF_PATH}/$SoundFile volume=100><a href=../../$Guts{guts_REF_PATH}/$SoundFile><font size=-2>[$SoundFile, $str_y $language_bundle->{'size_unit'}]</font></a>"   ) );
          }
        
        
        
        $x="[$ImageRef, $WidthesDesBigImages{$ImageRef}  $HeightsDesBigImages{$ImageRef}, $str_x".$language_bundle->{'size_unit'}."]" ;
        $x=HTML::Element->new('font', 'size'=>-2)->push_content($x);
        $a2->push_content($x);
        $ITAG_TN->push_content('',['p'],$comment,@aa1,['br'],@descri,['br'],$a2, @SoundFileBunchHtml, ['P']);
      }	
  
      #Le I1AG est identique au ITAG sauf qu'il est ds un sous rp. Il faut donc rajouter '..'.    
      $I1AG_TN=$ITAG_TN->clone;
      
      $I1AG_TN->look_down('id',"A-$Fichier")->attr('href',transfolink("$ImageRef.html"));
      $I1AG_TN->look_down('id',"A2-$Fichier")->attr('href',transfolink("$ImageRef.html"));
      $I1AG_TN->look_down('id',"I-$Fichier")->attr('src',transfolink("../../$Guts{guts_TN_PATH}/$ChapitrLabel/$Fichier"));
  
      { ### presentation without graphics
        my ($comment, $a1, @desc, $x);
        $ITNG_TN=HTML::Element->new('li') ;
        $comment=HTML::Element->new('~comment','text'=>"gr#$NoDeChapitre, ph#$SmallCounter");
  
        $a1=HTML::Element->new(
            'a', 
#            'target'=>"_x_$GrandCounter",
            'target'=>"_blank",
            'href'=>transfolink("$ChapitrLabel/$ImageRef.html") );
        $a1->push_content($ImageRef);
        if (defined $DescriptionACD{$ImageRef})
          { @desc = ListLocalTreeBuilder ("- $DescriptionACD{$ImageRef}"); }
        else
          { @desc = "" ; }
        my $str_x=int($SizesDesBigImages{$ImageRef}/1024);
        $x="[$WidthesDesBigImages{$ImageRef}  $HeightsDesBigImages{$ImageRef}, $str_x".$language_bundle->{'size_unit'}."]" ;
        $ITNG_TN->push_content($comment,$a1,' ',$x,@desc);
      }
  
      { #Standard presentation for image only with a picture in a <center> and a table with (<PREV...NEXT> )
      #Z1AG
      my $Z1AG_FilePath = File::Spec->catfile($ALBUM_DIR_NEW, File::Spec->catfile($ChapitrLabel, "$ImageRef.html"));
      
        my ($img, $a1, $a2, @desc, $x, $c);
        #On utilise la hauteur spcifie $Height dans le fichier de config. On en dduit la largeur.
        #Mais si l'image de ref est plus petite que $Height, il ne faut pas zoomer, et a ne sert  rien de la rendre cliquable
        my ($BigWidth, $BigHeight);
        my $fMaxZoomInHtml=0;
        if ($Height >= $HeightsDesBigImages{$ImageRef})
          {
  	$BigWidth  = $WidthesDesBigImages{$ImageRef} ; 
  	$BigHeight = $HeightsDesBigImages{$ImageRef} ; 
  	$fMaxZoomInHtml=1;
  	}
        else
          { 
  	$BigHeight = $Height ; 
          $BigWidth = int($WidthesDesBigImages{$ImageRef} / $HeightsDesBigImages{$ImageRef} * $Height) ;
  	}
        $img=HTML::Element->new(
            'img', 
            'src'=>transfolink("../../$Guts{guts_REF_PATH}/$ImageRef"),
            'width'=>$BigWidth,
            'height'=>$BigHeight );
        my $str_x=int($SizesDesBigImages{$ImageRef}/1024);
        $x="[$ImageRef, $WidthesDesBigImages{$ImageRef}  $HeightsDesBigImages{$ImageRef}, $str_x".$language_bundle->{'size_unit'}."]" ;
  
        $a2=HTML::Element->new(
            'a', 
            'href'=>transfolink("../../$Guts{guts_REF_PATH}/$ImageRef") );
        if ( ! $fMaxZoomInHtml )
          { $a1=$a2->clone;
  	  $a1->push_content($img); }
        else
          { $a1 = $img }
        
        $a2->push_content($x);
  
        if (defined $DescriptionACD{$ImageRef})
          { @desc = (ListLocalTreeBuilder ("$DescriptionACD{$ImageRef} "), ' '); }
        else
          { @desc = ("") ; }
        $c=HTML::Element->new('center');
        $c->push_content($a1,['br'],@desc,$a2);
        
  
        if ( $SoundFile ne '' )
          {
          my $str_y = int($SizeSoundFile/1024);
  
          $c->push_content(ListLocalTreeBuilder("
          <br><b>Sound file: </b>"), @descSoundFile, ListLocalTreeBuilder("<embed autostart=false hidden=false loop=false 
          src=../../$Guts{guts_REF_PATH}/$SoundFile volume=100><a href=../../$Guts{guts_REF_PATH}/$SoundFile>[$SoundFile, $str_y $language_bundle->{'size_unit'}]</a>"
            ));
  
  #        $c->push_content(['br'],HTML::Element->new_from_lol(['B', "Sound file: "]),
  #                  @desc, 
  #                  HTML::Element->new('EMBED', 'src' => "../../$Guts{guts_REF_PATH}/$SoundFile", 'autostart'=>'false', 'loop'=>'false', 'volume'=>'100', 'hidden'=>'false'), 
  #                  "[", 
  #                  HTML::Element->new('A', 'href' => "../../$Guts{guts_REF_PATH}/$SoundFile")->push_content($SoundFile),
  #                  ", $str_x ".$language_bundle->{'size_unit'}."]"
  #                  );  
          }
  
        
        my $Z1AG_Html = $X_Html->clone;
  
        $Z1AG_Html->look_down('id','X_Body')->attr('background',"../../".$BODY{'background'}) if defined($BODY{'background'});
      
      
        $Z1AG_Html->look_down('id','X_Title')->push_content($ImageRef);
        $Z1AG_Html->look_down('id','X_FileDesc')->attr('text'," file descriptor = Z1AG (Zoom 1 avec graphiques),$CR marker=$Stamp$CR");
        $Z1AG_Html->look_down('id','X_H1')->delete;
        $Z1AG_Html->look_down('id','X_Intro')->delete;
        $Z1AG_Html->look_down('id','X_Frise')->delete;
        $Z1AG_Html->look_down('id','X_Address')->delete;
  
        my ($tdprec, $tdr, $tdsuiv, $ta);
        $tdprec=HTML::Element->new('td','width'=>"33%", 'align'=>'center');
        $tdr=HTML::Element->new   ('td','width'=>"34%", 'align'=>'center');
        $tdsuiv=HTML::Element->new('td','width'=>"33%", 'align'=>'center');
    
        if ( ! "$PhotoPrec" eq "" )
          {        #Une photoprec
          $tdprec->push_content(HTML::Element->new('a',
        		                               'href'=>transfolink("$PhotoPrec.html") )->
                      push_content(HTML::Element->new('i')->push_content($language_bundle->{'prev_picture'}) )
      		           );
          }
        $tdr->push_content( 
          HTML::Element->new_from_lol(
           ['i', $language_bundle->{'back_to_index_1'}, 
            ['br'],
            ['a', {'href',transfolink($Guts{guts_I1AG_FN})}, $language_bundle->{'back_to_index_2'}]
           ]) );

##HTML::Element->new_from_lol(
#
#             HTML::Element->new('i')-> push_content(  ))
#      		       );
        if ( defined $NoDesImages{$SmallCounter + 1} )
          {        #Une photosuiv
  
          $tdsuiv->push_content(HTML::Element->new('a',
        		'href'     =>transfolink("$NoDesImages{$SmallCounter + 1}.html"))->
                  push_content(HTML::Element->new('i')->push_content($language_bundle->{'next_picture'})
      		));
          }
        $ta=HTML::Element->new('table','border'=>0,'width'=>"100%", 'align'=>'center');
        $ta->push_content(HTML::Element->new('tr')->push_content($tdprec, $tdr, $tdsuiv));
        $ta=HTML::Element->new('center')->push_content($ta);
        $ta=HTML::Element->new('hr')->push_content($ta);
  
        $Z1AG_Html->look_down('id','X_Corpse')->push_content($c,$ta);
      	  
        open(OUT_Z1AG, "> $Z1AG_FilePath") || return set_error("$MEID-055910 - Impossible d'ouvrir $Z1AG_FilePath: $!") ;
        print OUT_Z1AG Workaround_unicode_html($Z1AG_Html->as_HTML(undef,"  "));
        close OUT_Z1AG ;
        $Z1AG_Html->delete;
      }
  
      #Nous insrons cet arbre dans l'arbre parent niveau chapitre
      $ITNG_ChapitrContent->push_content($ITNG_TN);
      $ITAG_ChapitrContent_sub->push_content($ITAG_TN);
      $I1AG_ChapitrContent_sub->push_content($I1AG_TN);
  
      #Nous prenons maintenant en considration le dcoupage en colonnes
      if ($ColCounter == $NbCol)
        {
        $ITAG_ChapitrContent->push_content($ITAG_ChapitrContent_sub);
        $ITAG_ChapitrContent_sub=HTML::Element->new('tr');
        $I1AG_ChapitrContent->push_content($I1AG_ChapitrContent_sub);
        $I1AG_ChapitrContent_sub=HTML::Element->new('tr');
        $ColCounter = 0 ; 
        }
      $PhotoPrec = $ImageRef ;
      }
  
    if ($ColCounter == $NbCol)
      {
      ITAG_ChapitrContent_sub->delete;
      I1AG_ChapitrContent_sub->delete;
      }
    else  
      {
      $ITAG_ChapitrContent->push_content($ITAG_ChapitrContent_sub);
      $I1AG_ChapitrContent->push_content($I1AG_ChapitrContent_sub);
      }
  
    #Nous Avons l'arbre qui correspond  la liste des thumbnails. On l'insre dans le descriptif HTML d'un chapitre
    #Ceci correspond aux tags parents de ...ChapitrContent
    
    my ($ITAG_ChapitrDeco, $ITNG_ChapitrDeco, $I1AG_ChapitrDeco);
    {
    #Intro d'un chapitre une fois qu'on dispose de l'arbre des thumbnails $ITAG_ChapitrContent
      #ITAG
      
      #On met le pack de thumbnail centr
      $ITAG_ChapitrContent=HTML::Element->new('center')->push_content($ITAG_ChapitrContent);
    
      my ($a,$h2, $comment, @descri,$hr);
      $a=HTML::Element->new('a','name'=>$ChapitrLabel);
      $comment=HTML::Element->new('~comment','text'=>"gr#$NoDeChapitre");
      if (defined $DescriptionACD{$ChapitrLabel})
        { @descri = ListLocalTreeBuilder ($DescriptionACD{$ChapitrLabel}); }
      else
        { @descri = ($ChapitrLabel) ; }
      $h2=HTML::Element->new('h2');
      $h2->push_content($comment,$a,@descri);
      
      if ( $NoDeChapitre > 1 )
        { $hr=HTML::Element->new('hr','width'=>'80%'); }
      else
        { $hr='' ; }
      
      $ITAG_ChapitrDeco=HTML::Element->new('p');
      if ( $SmallCounter > 0 )
        { $ITAG_ChapitrDeco->push_content($hr,$h2,$ITAG_ChapitrContent); }
      else
        {
        $ITAG_ChapitrContent->delete ;
        $ITAG_ChapitrDeco->push_content($hr,$h2,['center',['i','sans']]);
        }
        
    }
  
    {
      #ITNG
      
      my ($comment, @descri);
      $comment=HTML::Element->new('~comment','text'=>"gr#$NoDeChapitre");
      if (defined $DescriptionACD{$ChapitrLabel})
        { @descri = ListLocalTreeBuilder ($DescriptionACD{$ChapitrLabel}); }
      else
        { @descri = ($ChapitrLabel) ; }


      #On met le pack de thumbnail dans un li
      $ITNG_ChapitrDeco=HTML::Element->new('li')->push_content(HTML::Element->new('a', 'name'=>$ChapitrLabel),$comment,@descri,$ITNG_ChapitrContent);
    }
  
    {
      #I1AG
      $I1AG_ChapitrContent=HTML::Element->new('center')->push_content($I1AG_ChapitrContent);
  
      my (@descri);  
      if (defined $DescriptionACD{$ChapitrLabel})
        { @descri = ListLocalTreeBuilder ($DescriptionACD{$ChapitrLabel}); }
      else
        { @descri = ($ChapitrLabel) ; }
  
      my $I1AG_Html = $X_Html->clone;
            $I1AG_Html->look_down('id','X_Body')->attr('background',"../../".$BODY{'background'}) if defined($BODY{'background'});
  
      $I1AG_Html->look_down('id','X_Title')->push_content($TitrePrincipal,' - ',@descri);
      $I1AG_Html->look_down('id','X_FileDesc')->attr('text'," gr#$NoDeChapitre, file descriptor = I1AG (Index 1 chapitre avec graphiques),$CR marker=$Stamp$CR");
      $I1AG_Html->look_down('id','X_H1')->push_content(CloneList(@Titre_principal_HTML),['br'],CloneList(@descri));
      #$I1AG_Html->look_down('id','X_Intro')->delete;
            $I1AG_Html->look_down('id','X_IntroImg')->push_content($I1AG_Intro_img);
            $I1AG_Html->look_down('id','X_IntroMenu')->push_content($I1AG_Intro_content);
  
      $I1AG_Html->look_down('id','X_Corpse')->push_content($I1AG_ChapitrContent);
  
  ##Construction du bloc 'chapitre suivant, chapitre prec'
      {
        my ($tdprec, $tdr, $tdsuiv, $ta);
        $tdprec=HTML::Element->new('td','width'=>"33%", 'align'=>'center');
        $tdr=HTML::Element->new   ('td','width'=>"34%", 'align'=>'center');
        $tdsuiv=HTML::Element->new('td','width'=>"33%", 'align'=>'center');
      
        if ( $NoDeChapitre > 1  )
          {
  	my $ChapitrPrecLabel=$DirnameDesChapitres{$NoDeChapitre - 1};
          if (defined $DescriptionACD{$ChapitrPrecLabel})
            { @descri = ListLocalTreeBuilder ($DescriptionACD{$ChapitrPrecLabel}); }
          else
            { @descri = ($ChapitrPrecLabel) ; }
          $tdprec->push_content(HTML::Element->new('a',
        		                               'href'=>transfolink("../$ChapitrPrecLabel/$Guts{guts_I1AG_FN}") )->
                      push_content(['i',$language_bundle->{'prev_chapter'},['br']],['b',@descri] )
      		           );
          }
        $tdr->push_content(HTML::Element->new('a',
        		'href'     =>transfolink("../$Guts{guts_ATAG_FN}"))->
                    push_content(HTML::Element->new('i')->push_content($language_bundle->{'back_to_start'}))
      		       );
        if ( $NoDeChapitre < $NbDeChapitres )
          { 
  	my $ChapitrSuivLabel=$DirnameDesChapitres{$NoDeChapitre + 1};
          if (defined $DescriptionACD{$ChapitrSuivLabel})
            { @descri = ListLocalTreeBuilder ($DescriptionACD{$ChapitrSuivLabel}); }
          else
            { @descri = ($ChapitrSuivLabel) ; }
          $tdsuiv->push_content(HTML::Element->new('a',
        		                               'href'=>transfolink("../$ChapitrSuivLabel/$Guts{guts_I1AG_FN}") )->
                      push_content(['i',$language_bundle->{'next_chapter'},['br']],['b',@descri] )
      		           );
          }
        $ta=HTML::Element->new('table','border'=>0,'width'=>"100%", 'align'=>'center');
        $ta->push_content(HTML::Element->new('tr')->push_content($tdprec, $tdr, $tdsuiv));
        $ta=HTML::Element->new('center')->push_content($ta);
  #      $ta=HTML::Element->new('hr')->push_content($ta);
        
        $I1AG_Html->look_down('id','X_Corpse')->push_content($ta);
  
      }
  
      open(OUT_I1AG, "> $I1AG_Path") || return set_error("$MEID-055923 - Impossible d'ouvrir $I1AG_Path: $!") ;
      print OUT_I1AG Workaround_unicode_html($I1AG_Html->as_HTML(undef,"  "));
      close OUT_I1AG ;
      $I1AG_Html->delete; # BUG here: when we delete this, we also delete the content of the trees included in @Titre_principal_HTML and @descri.
  
    }
    
  
    $ITAG_Corpse->push_content($ITAG_ChapitrDeco);
    $ITNG_ListContent->push_content($ITNG_ChapitrDeco);
  
    closedir SRC_CHAPITR_DIR;
    $ChapitrPrec=$ChapitrLabel ;
    }

##  $ITNG_ListContent->push_content('foo/bar');

  print_msg ("\nHTML writing\n");
  
  #Pour ATAG
  
  
  #  ($HeightsDesThumbNails{"header$Ext"}, $WidthesDesThumbNails{"header$Ext"}, $SizesDesThumbNails{"header$Ext"};
  
  $TexteAlbum='';
  if ( $HeadPhotIndBasename && defined $DescriptionACD{$HeadPhotIndBasename} )
    { $TexteAlbum = $DescriptionACD{$HeadPhotIndBasename} ; }
  
  $ATAG_Html->look_down('id','X_Title')->push_content("$TitrePrincipal");
  $ATAG_Html->look_down('id','X_FileDesc')->attr('text'," file descriptor = ATAG (Album toutes Avec graphics),$CR marker=$Stamp$CR");

  $ATAG_Html->look_down('id','X_H1')->push_content(CloneList(@Titre_principal_HTML));
  $ATAG_Html->look_down('id','X_IntroText')->push_content(ListLocalTreeBuilder ($TexteAlbum));
  $ATAG_Html->look_down('id','X_IntroImg')->push_content(HTML::Element->new('img', 'src'=>"../$HeadPhotIndBasename", 'height'=>$HeightsDesThumbNails{$HeadPhotIndBasename}, 'width'=>$WidthesDesThumbNails{$HeadPhotIndBasename}));
  $ATAG_Html->look_down('id','X_Frise')->tag('~comment');
  $ATAG_Html->look_down('id','X_Frise')->attr('text','');
  
  $X_any= $ATAG_Html->look_down('id','X_IntroMenuListe');
  $X_any->replace_with($ATAG_UpChapitrList)->delete();
  
  #Pour ITAG
  $ITAG_Html->look_down('id','X_Title')->push_content("$TitrePrincipal - ".$language_bundle->{'full_index'});
  $ITAG_Html->look_down('id','X_FileDesc')->attr('text'," file descriptor = ITAG (Index toutes avec graphics),$CR marker=$Stamp$CR");
  $ITAG_Html->look_down('id','X_H1')->push_content((CloneList(@Titre_principal_HTML),['br'],$language_bundle->{'full_index'}));
  $ITAG_Html->look_down('id','X_IntroText')->push_content((ListLocalTreeBuilder($TexteAlbum)));
  $ITAG_Html->look_down('id','X_IntroImg')->push_content(HTML::Element->new('img', 'src'=>"../$HeadPhotIndBasename", 'height'=>$HeightsDesThumbNails{$HeadPhotIndBasename}, 'width'=>$WidthesDesThumbNails{$HeadPhotIndBasename}));
  
  $X_any=HTML::Element->new('a','href'=>$Guts{guts_ATAG_FN})->push_content($language_bundle->{'back_to_start'},['p']);
  $ITAG_Html->look_down('id','X_TailerText')->unshift_content($X_any);
  
  $X_any= $ITAG_Html->look_down('id','X_IntroMenuListe');
  $X_any->replace_with($ITAG_ChapitrList)->delete();
  
  
  #Pour ITNG
  $ITNG_Html->look_down('id','X_Title')->push_content("$TitrePrincipal - ".$language_bundle->{'no_pic_full_index'});
  $ITNG_Html->look_down('id','X_FileDesc')->attr('text'," file descriptor = ITNG (Index toutes NO graphics),$CR marker=$Stamp$CR");
  $ITNG_Html->look_down('id','X_H1')->push_content(CloneList(@Titre_principal_HTML),['br'],$language_bundle->{'no_pic_full_index'});
  $ITNG_Html->look_down('id','X_IntroText')->push_content((ListLocalTreeBuilder($TexteAlbum)));
  $ITNG_Html->look_down('id','X_IntroImg')->push_content(HTML::Element->new('img', 'src'=>"../$HeadPhotIndBasename", 'height'=>$HeightsDesThumbNails{$HeadPhotIndBasename}, 'width'=>$WidthesDesThumbNails{$HeadPhotIndBasename}));
  
  $X_any=HTML::Element->new('a','href'=>$Guts{guts_ATAG_FN})->push_content($language_bundle->{'back_to_start'},['p']);
  $ITNG_Html->look_down('id','X_TailerText')->unshift_content($X_any);
  
  $X_any= $ITNG_Html->look_down('id','X_IntroMenuListe');
  $X_any->replace_with($ITNG_ChapitrList)->delete();
#  $X_any->push_content('foo/bar');
  
  #Pour RDIR
  
  $RDIR_Html->look_down('id','X_Title')->push_content("$TitrePrincipal");
  $RDIR_Html->look_down('id','X_H1')->push_content(CloneList(@Titre_principal_HTML), ": Wait!");
  $RDIR_Html->unshift_content(HTML::Element->new('meta','content'=>"0; url=$Guts{guts_ALBUM_PATH}",'http-equiv'=>'refresh')) ;
  $RDIR_Html->look_down('id','X_FileDesc')->attr('text'," file descriptor = RDIR (auto redirection),$CR marker=$Stamp$CR");
  
  $RDIR_Html->look_down('id','X_Corpse')->push_content(
    ['div', {'align'=>'center', 'id'=>'explicit_redir'},
      ['B', "The album you want is there: ", 
      	['A', {href => "$Guts{guts_ALBUM_PATH}"}, "$Guts{guts_ALBUM_PATH}"], ['p'], 
  	"L'album que vous cherchez est ici: ",
  	['A', {href => "$Guts{guts_ALBUM_PATH}"}, "$Guts{guts_ALBUM_PATH}"], ['p']
      ]
    ]
          ) ;
  
  
  open(ITNG_HANDLE, "> $ITNG_Path") || return set_error("$MEID-055935 - Impossible d'ouvrir $ITNG_Path: $!") ;
  print ITNG_HANDLE Workaround_unicode_html($ITNG_Html->as_HTML(undef,'  '));
  close ITNG_HANDLE ;
  
  open(OUT_INDEX_TOUTES, "> $ITAG_Path") || return set_error("$MEID-055949 - Impossible d'ouvrir $ITAG_Path: $!" );
  print OUT_INDEX_TOUTES Workaround_unicode_html($ITAG_Html->as_HTML(undef,'  '));
  close OUT_INDEX_TOUTES ;
  
  
  open(OUT_ALBUM_TOUTES, "> $ATAG_Path") || return set_error("$MEID-06000 - Impossible d'ouvrir $ATAG_Path: $!" );
  print OUT_ALBUM_TOUTES Workaround_unicode_html($ATAG_Html->as_HTML(undef,'  '));
  close OUT_ALBUM_TOUTES ;
  
  #Here: we do not create the redir index on it's final place. We create it in a tempo place first. If it is different, we replace the obsolete one. If not, we remove the tempo. The point is: do not change the file if not necessary: it saves upload time, and keep stampdates accurate.
  
  open(OUT, "> $RDIR_Path.tmp") || return set_error("$MEID-06001 - Impossible d'ouvrir $RDIR_Path.tmp: $!") ;
  print OUT Workaround_unicode_html($RDIR_Html->as_HTML(undef,'  '));
  close OUT ;
  
    if ( ! -f $RDIR_Path || significant_diff ($RDIR_Path, "$RDIR_Path.tmp") )
      {
      unlink $RDIR_Path if ( -f $RDIR_Path );
      move ("$RDIR_Path.tmp", $RDIR_Path);
      }
    else
      {
      unlink ("$RDIR_Path.tmp");
      }
  
  #Create an empty file for server identification
  #  The name of the file is the ftp address of the server.
  if ( $FtpMark_FileName ne '.' ) 
    { open (OUT, "> $FtpMark_Path") || return set_error("$MEID-06002 - Unable to write in $FtpMark_Path.\n") ;
    close (OUT); }
  
  
  
  
    
  #####################################################################
  #####                   Smart update of album                   #####
  #####################################################################
  my $ALBUM_DIR = File::Spec->catfile ($MainDir,$Guts{guts_ALBUM_PATH});
  deltree ($ALBUM_DIR_OLD) if (-d $ALBUM_DIR_OLD ) ;
  if (-d $ALBUM_DIR )
    { move ($ALBUM_DIR, $ALBUM_DIR_OLD) || return set_error("$MEID-06003 - Error 1329: Unable to move $ALBUM_DIR to $ALBUM_DIR_OLD: $!" ); }
  
  
  print_msg ("Smart update ");
  
  $File_Find_Data_Struct{'ALBUM_DIR'}=$ALBUM_DIR;
  $File_Find_Data_Struct{'ALBUM_DIR_OLD'}=$ALBUM_DIR_OLD;
  $File_Find_Data_Struct{'ALBUM_DIR_NEW'}=$ALBUM_DIR_NEW;
  $File_Find_Data_Struct{'count_touched'}=0;
  $File_Find_Data_Struct{'count_total'}=0;
  
  find({wanted => \&smart_update_old_new_album}, $ALBUM_DIR_NEW);  #This is very important. For each file in new. If it is identical than the one is old, move old to final directory. Otherwise: move new to final directory.
         							    #Differences in stampdate and marker does not count
  							    #The point is: do not touch file when not necessary: it saves time on ftp upload, and keep stampdate accuraccy..
  
  print_msg ("$File_Find_Data_Struct{'count_touched'}/$File_Find_Data_Struct{'count_total'}\n");
  
  
  return set_error("$MEID-060129 - Missing directory $ALBUM_DIR.\n") unless -d $ALBUM_DIR ;
  
  #####################################################################
  #####                   Modification des logs                   #####
  #####################################################################
  print_msg ("Log updates");
  my ($smart_count_touched, $smart_count_total)=(0,0);
  if ( -d $LOG_DIR)
    {
    foreach my $Log (@ListeDesLogs)
      {
      my $oldfile=File::Spec->catfile($LOG_DIR,$Log);
      my $newfile=File::Spec->catfile($LOG_DIR,$Log.'.tmp');
      
      SpecifieImgAttr($oldfile,$newfile);
  
      ChompExtra0d($newfile);
      WordWrapp80($newfile) if $opt_mode_wrap ;
      
      $smart_count_total++;
      if ( -f $newfile && (! -f $oldfile || significant_diff ($oldfile, $newfile) ) )
        {
        unlink $oldfile if ( -f $oldfile );
        move ($newfile, $oldfile);
        $smart_count_touched++;
        }
      else
        {
        unlink $newfile if ( -f $newfile );
        }
      }
  
  #On s'assure qu'avec tous les logs, chaque TN est prsent.
  #Ce mode est lorqu'on veut que les logs incluent toutes les photos
    foreach ( keys (%PremChapitrDeCetteImage) )
      {
      if ( ! defined $ThumbNailInLog{$_} && $opt_mode_Warning ) 
        { print STDERR "Warning: $PremChapitrDeCetteImage{$_}/$_ not in log.\n" ; }
      }
    }
  print_msg (" ($smart_count_touched/$smart_count_total).\n");  
  
  
  print_msg ("Cleaning.\n");
  deltree ($ALBUM_DIR_OLD) if ( -d $ALBUM_DIR_OLD);
  deltree ($ALBUM_DIR_NEW) if ( -d $ALBUM_DIR_NEW);
  print_msg ("Done.\n");
  
  #####################################################################
  #####             End of album  creation                        #####
  #####################################################################
  return 1;
  }  # end of album_create_main

sub get_stampdate
  {
  my @dte =localtime(time());
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
     (  0 ,  1  , 2    ,  3   , 4   ,   5  ,  6   , 7    ,  8);

  return sprintf("%0.2d/%0.2d/%0.4dAD %0.2d:%0.2d:%0.2d",
      $dte[$mday],
      $dte[$mon]+1,
      $dte[$year]+1900,
      $dte[$hour],
      $dte[$min],
      $dte[$sec]);
  }


#####################################################################
#####                       Templates de code                   #####
#####################################################################
#Nouvel arbre
#Tag simple
#  HTML::Element->new('ul');
#Avec un tag, des attributs, et un contenu de type atome
#  HTML::Element->new('a','href'=>'index.html')->push_content('Index complet')
#
#Push
#push atome, push tag, push plusieurs lments
#$X->push_content('hello');$X->push_content(['hr']);$X->push_content('hello',['hr'],@L);


#usage insert_in_descriptionACD_hachoir($file, $mode)
  #  $mode is 'filemode' or 'parentmode'
  #  in parentmode, the name of the parent directory is concat to teh filename (last leaf only)
#   will open file $file (descript.ion) and put it's content in DescriptionACD, either with filename or fullpath.

sub insert_in_descriptionACD_hachoir
  {
  my $FichDesc = $_[0];
  my $mode=$_[1];
  if ( -r $FichDesc ) 
    {
    my ($DescDir, $basename_of_dir);
    $DescDir = dirname($FichDesc);
    $basename_of_dir=basename($DescDir);
    open (FICHIER_DESCRIPT, "< $FichDesc") || die "Error 2351 - unable to open $FichDesc";
    while ( <FICHIER_DESCRIPT> )
      {
      chomp ;
      
    #Si une espace est prsente dans le nom de fichier, le fichier des desc a des guillemets  
      my $ImageRef= lc($_) ;
      $ImageRef =~ s/^([^"][^ ]*) (.+)$/$1/i ;
      $ImageRef =~ s/^"([^"]+)" (.+)$/$1/i ;
      my $CommentaireImage = $_ ;
      $CommentaireImage =~ s/^([^"][^ ]*) (.+)$/$2/i ;
      $CommentaireImage =~ s/^"([^"]+)" (.+)$/$2/i ;
      
      #Ne retient que les commentaires lis  des fichiers effectivement prsents (sinon: pb)
      #D'autre part, le FS tant case insensitif, il faut convertir les noms de fichiers en lower case
      if ( -f File::Spec->catfile ($DescDir,$ImageRef) || -d File::Spec->catfile ($DescDir,$ImageRef) ) 
        { 
          if ($mode eq 'filemode')
            { $DescriptionACD{$ImageRef}= $CommentaireImage ; }
	  if ($mode eq 'parentmode') 
            { $DescriptionACD{File::Spec->catfile ($basename_of_dir,$ImageRef)}= $CommentaireImage ; }
	}
      }
    close (FICHIER_DESCRIPT) ;
    }
  }

sub LocalTreeBuilder_obs
  {
  my $string = $_[0] ;
  my $HTML=HTML::TreeBuilder->new ;
  $HTML->parse($string) ;
  $HTML->eof();
  my ($HEAD, $BODY) = $HTML->detach_content() ;
  my ($b) = $BODY->detach_content() ;
  $HTML->delete();
  $HEAD->delete();
  $BODY->delete();
  return $b ;
  }

#Cette fonction renvoit une liste des lments parss.
sub ListLocalTreeBuilder
  {
  if ( defined $_[0] )
    {
    my $string = $_[0] ;
    my $HTML=HTML::TreeBuilder->new ;
    $HTML->store_comments(1);
    $HTML->parse($string) ;
    $HTML->eof();
    my ($HEAD, $BODY) = $HTML->detach_content() ;
    my (@b) = $BODY->detach_content() ;
    $HTML->delete();
    $HEAD->delete();
    $BODY->delete();
    return @b ;
    }
  else
    { return (); }
  }

# input is a list of HTML elements (example: obtained from  ListLocalTreeBuilder)
# output is a list identical containing clones.
sub CloneList
  {
  my @l=();
  foreach my $x (@_)
    {
    if ( ref($x) )
      { push (@l, $x->clone) ;}
    else
      { push (@l, $x); }
    }
  return @l;
  }

sub rmfile
 {
 my $dir = cwd ;
 unlink "$dir/$_" if ( -f "$dir/$_" ) ;
 }


#Open a file, and for each graphic in it: sets the heigh and width attribute
sub SpecifieImgAttr
  {
  my $SrcPath = $_[0] ;
  my $TgtPath = $_[1] ;
  die ("Error 0215: unable to read file $SrcPath\n") unless (-f $SrcPath && -r $SrcPath);

  my $SrcDir = dirname($SrcPath);
  my $SrcBasename = basename($SrcPath);
  
  
  my $tree = HTML::TreeBuilder->new();
  $tree->store_comments(1);
  $tree->parse_file($SrcPath);
  
  my @ListeDesImagesALinker = () ;

  
  my $CurDir = cwd() ;
  chdir ($SrcDir) ;
    {
    $tree->traverse(
      [ # Callbacks;
        # pre-order callback:
        sub {
          my $x = $_[0];
  	  if ($x->tag eq 'img')
  	    {
    	    my $ImageRef = lc(basename($x->attr('src')));
	    #Si le fichier n'existe pas
    	    if ( ! -f $x->attr('src') )
	      {
  	      #Si le fichier n'existe pas et que le chemin est '.' et que c'est une image connue
    	      if ( transfolink($ImageRef) eq transfolink($x->attr('src')) &&
	           defined $NomDesTN{$ImageRef} && defined $PremChapitrDeCetteImage{$NomDesTN{$ImageRef}} )
	        {
	        #Juste le nom de l'image, c'est un raccourci: faire le repch:
	        my $grp=$PremChapitrDeCetteImage{$NomDesTN{$ImageRef}};
                $x->attr('src',transfolink("../$Guts{guts_TN_PATH}/$grp/$NomDesTN{$ImageRef}"));
	        }
	      elsif
	      #C'est peut-tre le thumbnail d'une image qui a chang de groupe
	            ( dirname($x->attr('src')) ne '' &&
		      defined $NomDesRef{$ImageRef} && 
		      defined $PremChapitrDeCetteImage{$ImageRef} )
	        { 
		print ("Moved thumbnail $ImageRef"); 
	        my $grp=$PremChapitrDeCetteImage{$ImageRef};
		if ( -f "..\\$Guts{guts_TN_PATH}\\$grp\\$ImageRef" )
                  { $x->attr('src',transfolink("../$Guts{guts_TN_PATH}/$grp/$NomDesRef{$ImageRef}")); 
		    print " from ", dirname($x->attr('src')), " to ../$Guts{guts_TN_PATH}/$grp.\n";
		  }
		else
		  { print ", mysterious moving though.\n"; }
		}
              else
	        { print ("Warning 0216: unable to read image file ", $x->attr('src'), ".\n"); }
  	      }
	    my $ImgBasename ;
	    #Si c'est un thumbnail...
  	    if ( -r $x->attr('src') && defined $NomDesRef{lc(basename($x->attr('src')))} )
  	      { 
    	      $ImgBasename = lc(basename($x->attr('src')));
	      $ImageRef = $NomDesRef{$ImgBasename} ;
	      if ( defined ($SizesDesThumbNails{$ImgBasename}) )
	        {
    	        $x->attr('width', $WidthesDesThumbNails{$ImgBasename});
    	        $x->attr('height', $HeightsDesThumbNails{$ImgBasename});
		$ThumbNailInLog{$ImgBasename}=1;
		}
	      my $ImgChapitrname = basename(dirname($x->attr('src')));
	      if ( -f "..\\$Guts{guts_ALB_PATH_N}\\$ImgChapitrname\\$ImageRef.html" &&
	           $x->parent->tag ne 'a' )
	        {
  	        my $A=HTML::Element->new('a','href'=>transfolink("../$Guts{guts_ALBUM_PATH}/$ImgChapitrname/$ImageRef.html"));
		my $H = { 'a'=>$A, 'img'=>$x } ;
		@ListeDesImagesALinker = (@ListeDesImagesALinker, $H);
		}
#Cas o l'image est dans un lien (qui n'existe pas en local), c'est que le lien est faux , d  un changement de chapitre. On le corrige.
#Bug: si c'est un lien vers l'extrieur non faux, il sera dtect comme fichier absent en local et corrig.
	      elsif ( -f "..\\$Guts{guts_ALB_PATH_N}\\$ImgChapitrname\\$ImageRef.html" &&
	           $x->parent->tag eq 'a' )
	        {
		my $a=$x->parent;
		my $url = URI->new($a->attr('href'));
		if ( (! defined $url->scheme) && (! -f $a->attr('href') ) ) 
		  { $a->attr('href',transfolink("../$Guts{guts_ALBUM_PATH}/$ImgChapitrname/$ImageRef.html"));}
		}
              if (defined $DescriptionACD{$ImageRef} )
	        {
		my @descri = ListLocalTreeBuilder ($DescriptionACD{$ImageRef});
		my $Descri=HTML::Element->new('~comment','text'=>'')->push_content(@descri);
    	        $x->attr('alt', $Descri->as_text);
                }
  	      }
  	    }
          return HTML::Element::OK; # keep traversing
        },
        # post-order callback:
        undef
      ],
      1, # don't call the callbacks for text nodes
    );


#Ceci se fait hors du traverse pour ne pas modifier la structure de l'arbre PENDANT qu'il le traverse
  foreach my $href (@ListeDesImagesALinker)
    { 
    my $a=$href->{'a'};
    my $img=$href->{'img'};
    $img->replace_with($a);
    $a->push_content($img);
    }


#2e traverse: aprs avoir corrig les href, je les passe en revue pour les vrifier.
    $tree->traverse(
      [ # Callbacks;
        # pre-order callback:
        sub {
          my $x = $_[0];
  	  if ($x->tag eq 'a' && defined $x->attr('href')  )
  	    {
            my $url = URI->new($x->attr('href'));
	    if ( (! defined $url->scheme) && defined $url->path &&
    (! -f $url->path ) && (! -d $url->path ) && $url->path ne '' )
              { print STDERR "Warning 2121: local href missing in $SrcBasename: ",  $url->path, ".\n"; }
  	    }
          return HTML::Element::OK; # keep traversing
        },
        # post-order callback:
        undef
      ],
      1, # don't call the callbacks for text nodes
    );
    }


$tree->objectify_text() ;  #On localise toutes les rf  $StampDate et on les remplace par la date dans une lignes isole. On fabrique la ligne isole en utilisant un commentaire qui contient un <CR>, et on insre un autre commentairfe qui contient le litral 'stampdate'.
  #Note: this method only support one occurence of the keyword per node
foreach my $lt ($tree->find_by_tag_name('~text'))
  { 
  if ($lt->attr('text') =~ m/^(.*)\$StampDate(.*)$/ ) 
    { 
    my $left=HTML::Element->new('~text','text'=>$1);
    my $right=HTML::Element->new('~text','text'=>$2);
    $lt->replace_with($left,$CR_in_comment->clone,HTML::Element->new('~comment','text'=>'stampdate'),$StampDate,$CR_in_comment->clone,$right) ;
    } 
  }
$tree->deobjectify_text() ;

#In the following: we look for a comment 'stampdate' which marks the stampdate
foreach my $lt ($tree->find_by_tag_name('~comment'))
  { 
  if ($lt->attr('text') =~ m/^stampdate$/ ) 
    { 
    $lt->parent->normalize_content;
#    print "Stampdate ", $lt->parent->content->[$lt->pindex + 1], " set to $StampDate\n";
    $lt->parent->content->[$lt->pindex + 1]=$StampDate;
    } 
  }


  chdir ($CurDir);

  open (OUT, "> $TgtPath") || die ("Error 0216b: unable to write in $TgtPath.\n");
  print (OUT Workaround_unicode_html($tree->as_HTML(undef,"  ")));
  close (OUT);

#  
#  
#    #Un bug ncessite sour DOS aprs ceci d'liminer les 0x0D.
#    if ( $^O =~ /mswin/i )
#      {
#      my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
#        $atime,$mtime,$ctime,$blksize,$blocks) = stat($SrcPath);
#      open (OUT, "< $SrcPath");
#      binmode OUT, ":raw" ;
#      read OUT, $_, $size ;
#      close (OUT);  
#      s/\x0D//g ;
#      open (OUT, "> $SrcPath");
#      print (OUT $_);
#      close (OUT) ;
#    }
    $tree->delete;
  }

sub ChompExtra0d
  {
  my $SrcPath = $_[0];
  my $TgtPath= "$SrcPath.out" ;
  open (IN, "< $SrcPath") || die "Error 0216c: unable to read from $SrcPath.\n" ;
  open (OUT, "> $TgtPath") || die "Error 0216d: unable to write in $TgtPath.\n" ;
  binmode IN, ":crlf" ;
  binmode OUT, ":crlf" ;
  while (<IN>)
    { chomp $_ ;
      $_ =~ s/\x0D//g ;
      $_ =~ s/\x0A//g ;
      print (OUT "$_\n");
    }
  close (IN);  
  close (OUT);  

  ( -f $SrcPath && -f $TgtPath ) || die "Missing $SrcPath or $TgtPath file.\n" ;
  unlink ($SrcPath) && move ($TgtPath, $SrcPath) ;
  }

sub Workaround_unicode_html
  {
  $_ = $_[0] ;
  s/&amp;#(\d+);/&#$1;/g ;
  s/&#13;//g ;     #This is another bug of the HTML package:  in <pre>, the 0x0A0D is interpreted as \10\n instead of \n and converted to &#13;\n
                   #  WOrkaround is to suppress all &#13; from file. 
  return $_ ;
  }
  
  
sub WordWrapp80
  {
  $Text::Wrap::columns = 80 ;
  
  my $SrcPath = $_[0];
  my $TgtPath= "$SrcPath.out" ;
  my $BckPath= "$SrcPath.bak" ;
  open (IN, "< $SrcPath") || die "Error 0216d: unable to read from $SrcPath.\n" ;
  open (OUT, "> $TgtPath") || die "Error 0216e: unable to write in $TgtPath.\n" ;
  binmode IN, ":crlf" ;
  binmode OUT, ":crlf" ;
  while (<IN>)
    { 
    chomp ;
    print OUT (wrap ('','', $_), "\n");
    }
  close (IN);  
  close (OUT);  

  ( -f $SrcPath && -f $TgtPath ) || die "Missing $SrcPath or $TgtPath file.\n" ;
  move ($SrcPath, $BckPath) && move ($TgtPath, $SrcPath) ;
  }

# usage expand_list_of_masks ($homedir, $list_of_masks)
#   will return the list of files (as @ list) designated by the list of regexp $list_of_masks (string) when submited from $homedir
#   will return undef in case of error or if $homedir is undef
#   will use current directory if $homedir is ''
#   will return ('') if $list_of_masks is () or no match
#   example:
#     expand_list_of_masks('c:\', "*.alb *.txt")
#     will produce ('foo.alb' 'bar.alb' 'x.txt')
#If value contains variable (such as ${TEMP}), then replace ${ENV} by its value
sub expand_list_of_masks
  {
  my $nbparam=2; my $funcname='expand_list_of_masks';
  ( $#_ +1 == $nbparam ) || die "Compile error: $funcname expects $nbparam parameters (you gave $#_ +1).\n";
  my ($homedir, $list_of_masks) = (@_);


  $homedir =~ s/(\$\{([^}]+)\})/$ENV{$2}/g ;
  $list_of_masks =~ s/(\$\{([^}]+)\})/$ENV{$2}/g ;
#  print "list_of_masks=$list_of_masks\n";

  return undef if ( ! defined ($homedir) ||  ! defined ($list_of_masks));


  my $f_ch_dir=0;
  my $X_pwd;
  $f_ch_dir=1 if ($homedir ne '') ;

  if ($f_ch_dir)
    {
    $X_pwd=cwd;
    chdir ($X_pwd) || return set_error_4p($MEID, 170012,"Unable to root itself on current directory");
    chdir ($homedir) || return set_error_4p($MEID, 170013,"Unable to cd to the specified directory '$homedir'");
    }

  my @str_expanded=glob ($list_of_masks);

#  print ("expanded=", @str_expanded, "\n");


  if ($f_ch_dir)
    {
    chdir ($X_pwd) || return set_error_4p($MEID, 170012,"Unable to root back to current directory");
    }

  @str_expanded = () if ($#str_expanded +1 == 1 && $str_expanded[0] eq '' ) ;

  return @str_expanded;

  }


#sub WordWrapp80
#  {
#  my $SrcPath = $_[0];
#  my $TgtPath= "$SrcPath.out" ;
#  open (IN, "< $SrcPath") || die "Unable to read from $SrcPath.\n" ;
#  open (OUT, "> $TgtPath") || die "Unable to write in $TgtPath.\n" ;
#  binmode IN, ":crlf" ;
#  binmode OUT, ":crlf" ;
#  while (<IN>)
#    { $_ =~ s/(.{80}[^ \t]*[ \t])/$1\n/g ;
#      print (OUT $_);
#    }
#  close (IN);  
#  close (OUT);  
#
#  ( -f $SrcPath && -f $TgtPath ) || die "Missing $SrcPath or $TgtPath file.\n" ;
#  unlink ($SrcPath) && move ($TgtPath, $SrcPath) ;
#  }

#Usage
#   Initialize_Structure_If_Needed($AbsStartDir, $opt_default_thumbsize);
#sub Initialize_Structure_If_Needed
#  {
#  my $AbsStartDir = $_[0] ;
#  my $opt_default_thumbsize= $_[1];
#  my $basename = basename($AbsStartDir) ;
#
#  my $tn_b_dir=File::Spec->catfile ($AbsStartDir,$Guts{guts_TN_PATH});
#  if ( ! -d $tn_b_dir )
#    {
#    mkdir $tn_b_dir, 777 ;
#    }
#  my $tn_chapter_dir=File::Spec->catfile ($tn_b_dir,$basename);
#  if ( ! -d $tn_chapter_dir )
#    {
#    mkdir $tn_chapter_dir, 777 ;
#    }
#
#
#  my $ref_dir=File::Spec->catfile ($AbsStartDir,$Guts{guts_REF_PATH});
#  if ( ! -d $ref_dir )
#    {
#    mkdir $ref_dir, 777 ;
#    opendir (START_DIR, $AbsStartDir) || die "Directory $AbsStartDir inaccessible" ;
#    my @DirDeStartdir = readdir(START_DIR) ;
#    close (START_DIR) ;
#    foreach my $I (@DirDeStartdir)
#      {
#      if ( is_image($I) )
#        {
#	#Je veux une surface constante
#
#        my $img_src=File::Spec->catfile ($AbsStartDir,$I);
#        my $img_dest=File::Spec->catfile ($tn_chapter_dir,"tn_$I");
#        my ($h, $w, $S, $h2, $w2, $S2) = create_thumbnail 
#                          ($img_src,
#                          $img_dest,
#                          $opt_default_thumbsize ) ;
#
#	print "Ref image $I ($w x $h -> $w2 x $h2)\n";
#
#        move($img_src,$ref_dir); 	
#	}
#      }
#    if ( -f File::Spec->catfile ($AbsStartDir,'descript.ion') )
#      {
#      copy (File::Spec->catfile ($AbsStartDir,'descript.ion'),
#            $ref_dir);
#      }
#    }
#  }
#
#usage: 
#   init_for_no_ini_direct_dir($startdir, $configfile, $opt_default_thumbsize);
#sub init_for_no_ini_direct_dir
#  {
#  my $startdir=$_[0];
#  my $configfile=$_[1];
#  my $opt_default_thumbsize= $_[2];
#
#  my $DefaultContentConfigFile = InitializeDefContentConfigFile($startdir) ;
#  Initialize_Structure_If_Needed($startdir, $opt_default_thumbsize);
#      
#  open (INIT_CONFIG_FILE, "> $configfile") || die "Error 0217: unable to initialize $configfile: $!";
#  print INIT_CONFIG_FILE $DefaultContentConfigFile;
#  close(INIT_CONFIG_FILE); 
#
#  }

#      #Create the first init file based on $1
#sub InitializeDefContentConfigFile
#  {
#  my $AbsStartDir = $_[0] ;
#  
#
#  my $hostname=hostname;
#  my $basename = basename($AbsStartDir) ;
#  my $IniStampDate=$StampDate;
#  
#  return 
#    
#"ThumbnailSurface	=$Guts{guts_def_thumb_surf}
#MainDir		=$AbsStartDir
#TitrePrincipal	=$basename
#Tailer	=File created $IniStampDate with software <a href=\"http://www.dunwich.org/soft/#albagtor\">\$generator</a> version \$STD_Version, last update \$StampDate from $hostname.
#Location=Third from the Sun
#Height		=400
#NbCol		=2
#FontFace	=Lucida sans MS
#Language=$Guts{guts_def_language}
#META_author		=
#META_description	=Part of photo album
#META_distribution	=private, limited to friends and relatives
#META_keywords	=
#META_ownership	=
#META_generator	=\$generator
#BODY_bgcolor	=white
#BODY_text	=black
#BODY_link	=blue
#BODY_vlink	=purple
#BODY_alink	=red
## BODY_background=background.gif
#remote_host	=
#remote_user	=
#remote_pwd 	=
#remote_root	=/$basename" ;
#
#  }
return 1 ;